(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('swagger-client/browser/index'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators'), require('@angular/common'), require('@angular/forms'), require('@angular/router'), require('ngx-markdown'), require('@angular/cdk/portal'), require('@angular/cdk/overlay'), require('ngx-ace-wrapper'), require('brace'), require('brace/mode/json'), require('brace/mode/xml'), require('ajv')) :
    typeof define === 'function' && define.amd ? define('@dhcode/openapi-viewer', ['exports', '@angular/core', 'swagger-client/browser/index', '@angular/common/http', 'rxjs', 'rxjs/operators', '@angular/common', '@angular/forms', '@angular/router', 'ngx-markdown', '@angular/cdk/portal', '@angular/cdk/overlay', 'ngx-ace-wrapper', 'brace', 'brace/mode/json', 'brace/mode/xml', 'ajv'], factory) :
    (global = global || self, factory((global.dhcode = global.dhcode || {}, global.dhcode['openapi-viewer'] = {}), global.ng.core, global.Swagger, global.ng.common.http, global.rxjs, global.rxjs.operators, global.ng.common, global.ng.forms, global.ng.router, global.ngxMarkdown, global.ng.cdk.portal, global.ng.cdk.overlay, global.ngxAceWrapper, null, null, null, global.Ajv));
}(this, (function (exports, core, Swagger, http, rxjs, operators, common, forms, router, ngxMarkdown, portal, overlay, ngxAceWrapper, brace, json, xml, Ajv) { 'use strict';

    Swagger = Swagger && Swagger.hasOwnProperty('default') ? Swagger['default'] : Swagger;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var httpMethods = ['get', 'put', 'post', 'delete', 'options', 'head', 'trace'];
    var securitySchemeTypes = ['apiKey', 'http', 'oauth2', 'openIdConnect'];
    var securitySchemeTypesWithScopes = ['oauth2', 'openIdConnect'];

    var formatExampleDate = new Date();
    formatExampleDate.setMilliseconds(0);
    formatExampleDate.setSeconds(0);
    var ɵ0 = function () { return ''; }, ɵ1 = function () { return 'user@example.com'; }, ɵ2 = function () { return formatExampleDate.toISOString(); }, ɵ3 = function () { return formatExampleDate.toISOString().substring(0, 10); }, ɵ4 = function () { return formatExampleDate.toISOString().substring(11); }, ɵ5 = function () { return '3fa85f64-5717-4562-b3fc-2c963f66afa6'; }, ɵ6 = function () { return 'example.com'; }, ɵ7 = function () { return '198.51.100.42'; }, ɵ8 = function () { return '2001:0db8:5b96:0000:0000:426f:8e17:642a'; }, ɵ9 = function () { return 0; }, ɵ10 = function () { return 0.0; }, ɵ11 = function () { return 0; }, ɵ12 = function (schema) { return (typeof schema.default === 'boolean' ? schema.default : true); }, ɵ13 = function () { return null; }, ɵ14 = function () { return null; };
    var formatExamples = {
        string: ɵ0,
        string_email: ɵ1,
        'string_date-time': ɵ2,
        string_date: ɵ3,
        string_time: ɵ4,
        string_uuid: ɵ5,
        string_hostname: ɵ6,
        string_ipv4: ɵ7,
        string_ipv6: ɵ8,
        number: ɵ9,
        number_float: ɵ10,
        integer: ɵ11,
        boolean: ɵ12,
        null: ɵ13,
        any: ɵ14
    };
    function examplePrimitive(schema) {
        var type = Array.isArray(schema.type) ? schema.type[0] : schema.type;
        var formatFunc = formatExamples[type + "_" + schema.format] || formatExamples[type];
        if (typeof formatFunc === 'function') {
            return formatFunc(schema);
        }
        return "Unknown: " + type;
    }
    function exampleFromSchema(schema) {
        var e_1, _a;
        var type = Array.isArray(schema.type) ? schema.type[0] : schema.type;
        if ('const' in schema) {
            return schema.const;
        }
        if ('default' in schema) {
            return schema.default;
        }
        if ('examples' in schema && schema.examples.length) {
            return schema.examples[0];
        }
        if (schema.enum) {
            return schema.enum[0];
        }
        if (type === 'object' || schema.properties) {
            var result = {};
            if (schema.example) {
                return schema.example;
            }
            if (!schema.properties) {
                return result;
            }
            var keys = Object.keys(schema.properties);
            try {
                for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                    var key = keys_1_1.value;
                    result[key] = exampleFromSchema(schema.properties[key]);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return result;
        }
        if (type === 'array') {
            var item = Array.isArray(schema.items) ? schema.items[0] : schema.items;
            return [exampleFromSchema(item)];
        }
        return examplePrimitive(schema);
    }
    function randomHex(len) {
        var preHex = len - 1 === 0 ? 0 : Math.pow(2, (4 * (len - 1)));
        var hex = Math.pow(2, (4 * len)) - 1;
        return Math.floor(preHex + Math.random() * (hex - preHex)).toString(16);
    }
    function getStarMatcher(pattern) {
        var escaped = escapeRegExpNoStar(pattern);
        return new RegExp('^' + escaped.replace(/\*/g, '.{0,50}') + '$');
    }
    function escapeRegExpNoStar(pattern) {
        return pattern.replace(/[.+?^${}()|[\]\\]/g, '\\$&');
    }
    function getJsonString(input) {
        if (typeof input === 'string' && input.match(/^({|\[|"|\d|-\d|null)/)) {
            return input;
        }
        return JSON.stringify(input, null, 2);
    }
    function serializeQueryParams(queryParams) {
        if (!queryParams) {
            return '';
        }
        return Object.keys(queryParams)
            .map(function (key) { return encodeURIComponent(key) + '=' + encodeURIComponent(queryParams[key]); })
            .join('&');
    }
    function parseQueryString(queryParams) {
        var e_2, _a;
        if (typeof queryParams !== 'string' || !queryParams.length) {
            return {};
        }
        var paramsList = queryParams.split('&');
        var params = {};
        if (paramsList.length) {
            try {
                for (var paramsList_1 = __values(paramsList), paramsList_1_1 = paramsList_1.next(); !paramsList_1_1.done; paramsList_1_1 = paramsList_1.next()) {
                    var line = paramsList_1_1.value;
                    var _b = __read(line.split('='), 2), key = _b[0], value = _b[1];
                    params[decodeURIComponent(key)] = decodeURIComponent(value);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (paramsList_1_1 && !paramsList_1_1.done && (_a = paramsList_1.return)) _a.call(paramsList_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        return params;
    }

    var OpenapiAuthService = /** @class */ (function () {
        function OpenapiAuthService(zone, http) {
            this.zone = zone;
            this.http = http;
            this.securitySchemes = new rxjs.BehaviorSubject([]);
            /**
             * Emits with the scheme name when its credentials have been updated
             */
            this.updatedCredentials = new rxjs.Subject();
            this.globalRequirements = [];
            this.currentWindow = window;
        }
        OpenapiAuthService.prototype.identifySchemes = function (spec) {
            this.securitySchemes.next(getSecurityInformation(spec));
            if (Array.isArray(spec.security)) {
                this.globalRequirements = spec.security;
            }
        };
        OpenapiAuthService.prototype.getAllRequirements = function (requirement) {
            return __spread(this.globalRequirements, (requirement || [])).filter(function (reqObject) { return Object.keys(reqObject).length > 0; });
        };
        OpenapiAuthService.prototype.getRequiredSchemes = function (requirement) {
            var e_1, _a;
            var _this = this;
            var result = [];
            var _loop_1 = function (reqs) {
                result.push(Object.keys(reqs).map(function (reqName) {
                    var schemaItem = _this.getSchema(reqName);
                    return {
                        name: reqName,
                        scopes: reqs[reqName],
                        securityScheme: schemaItem.securityScheme,
                        authenticated: schemaItem.authenticated
                    };
                }));
            };
            try {
                for (var _b = __values(this.getAllRequirements(requirement)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var reqs = _c.value;
                    _loop_1(reqs);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return result;
        };
        OpenapiAuthService.prototype.getAuthStatus = function (requirements) {
            var authStatus = 'none';
            var allRequirements = this.getAllRequirements(requirements);
            if (allRequirements && Object.keys(allRequirements).length) {
                authStatus = 'required';
                if (this.hasAnyAuthorization(allRequirements)) {
                    authStatus = 'ok';
                }
            }
            return authStatus;
        };
        OpenapiAuthService.prototype.hasAnyAuthorization = function (requirements) {
            var e_2, _a;
            var _this = this;
            if (!requirements || !requirements.length) {
                return true;
            }
            var _loop_2 = function (req) {
                var reqNames = Object.keys(req);
                if (reqNames.length && reqNames.every(function (rn) { return _this.hasRequirement(rn, req[rn]); })) {
                    return { value: true };
                }
            };
            try {
                // one needs to be fulfilled
                for (var requirements_1 = __values(requirements), requirements_1_1 = requirements_1.next(); !requirements_1_1.done; requirements_1_1 = requirements_1.next()) {
                    var req = requirements_1_1.value;
                    var state_1 = _loop_2(req);
                    if (typeof state_1 === "object")
                        return state_1.value;
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (requirements_1_1 && !requirements_1_1.done && (_a = requirements_1.return)) _a.call(requirements_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return false;
        };
        OpenapiAuthService.prototype.hasRequirement = function (reqName, scopes) {
            var scheme = this.getSchema(reqName);
            if (scheme &&
                scheme.authenticated &&
                scheme.securityScheme.type &&
                securitySchemeTypesWithScopes.includes(scheme.securityScheme.type)) {
                var credentials_1 = scheme.credentials;
                if (credentials_1 && credentials_1.scopes && scopes.every(function (s) { return credentials_1.scopes.includes(s); })) {
                    return true;
                }
            }
            else if (scheme && scheme.authenticated) {
                return true;
            }
            return false;
        };
        OpenapiAuthService.prototype.getSchema = function (name) {
            return this.securitySchemes.value.find(function (s) { return s.name === name; });
        };
        OpenapiAuthService.prototype.updateCredentials = function (name, credentials, authenticated, remember) {
            if (remember === void 0) { remember = false; }
            if (typeof name !== 'string' || !name.length) {
                throw new Error('No credentials name given');
            }
            var schema = this.getSchema(name);
            schema.authenticated = authenticated;
            if (schema.authenticated) {
                schema.credentials = credentials;
                if (remember) {
                    schema.remember = true;
                    writeCredentialsStore(name, credentials);
                }
            }
            else {
                schema.remember = false;
                schema.credentials = null;
                clearCredentialsStore(name);
            }
            this.updatedCredentials.next(name);
        };
        OpenapiAuthService.prototype.runOAuthAuthorization = function (name, credentials) {
            var _this = this;
            var scheme = this.getSchema(name);
            if (!scheme || !credentials) {
                return rxjs.throwError(new Error('Unknown scheme or no credentials given'));
            }
            scheme.credentials = credentials;
            scheme.remember = true;
            writeCredentialsStore(name, credentials);
            if (credentials.flow === 'implicit' || credentials.flow === 'authorizationCode') {
                return new rxjs.Observable(function (subscriber) {
                    var url = buildAuthorizationUrl(scheme.securityScheme, credentials, name);
                    var service = _this;
                    _this.currentWindow.handleOAuthCallback = function (fragment) {
                        // called from other window
                        return service.zone.run(function () {
                            return service.handleOAuthCallback(fragment).then(function () {
                                subscriber.next(true);
                                subscriber.complete();
                            }, function (err) {
                                subscriber.error(err);
                            });
                        });
                    };
                    _this.currentWindow.open(url, '_blank');
                });
            }
            if (credentials.flow === 'clientCredentials') {
                var tokenUrl = getTokenBaseUrl(scheme.securityScheme, 'clientCredentials');
                return this.requestToken(tokenUrl, 'client_credentials', credentials).pipe(operators.map(function (token) {
                    credentials.token = token;
                    _this.updateCredentials(name, credentials, true, true);
                    return true;
                }));
            }
            if (credentials.flow === 'password') {
                var tokenUrl = getTokenBaseUrl(scheme.securityScheme, 'password');
                return this.requestToken(tokenUrl, 'password', credentials).pipe(operators.map(function (token) {
                    credentials.token = token;
                    _this.updateCredentials(name, credentials, true, true);
                    return true;
                }));
            }
            return rxjs.throwError(new Error('Unknown flow'));
        };
        /**
         * @param params
         * eg. access_token=8c665834-6a43-4704-81d3-42d311a1ab91&token_type=bearer&expires_in=20&scope=read%20write:pets%20write%20read:pets
         */
        OpenapiAuthService.prototype.handleOAuthCallback = function (params) {
            return __awaiter(this, void 0, void 0, function () {
                var scheme, credentials;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.currentWindow.opener && this.currentWindow.opener.handleOAuthCallback)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.currentWindow.opener.handleOAuthCallback(params)];
                        case 1:
                            _a.sent();
                            this.currentWindow.close();
                            return [2 /*return*/];
                        case 2:
                            if (!params.state) {
                                return [2 /*return*/];
                            }
                            scheme = this.getSchema(params.state);
                            if (!scheme || !scheme.credentials) {
                                return [2 /*return*/];
                            }
                            credentials = scheme.credentials;
                            if (params.access_token) {
                                return [2 /*return*/, this.updateByImplicitFlow(scheme.name, credentials, params)];
                            }
                            if (!params.code) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.updateByCodeFlow(scheme, credentials, params)];
                        case 3: return [2 /*return*/, _a.sent()];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        OpenapiAuthService.prototype.updateByImplicitFlow = function (name, credentials, params) {
            credentials.token = {
                access_token: params.access_token,
                token_type: params.token_type
            };
            if (params.expires_in) {
                credentials.token.expires_at = new Date().getTime() + parseInt(params.expires_in, 10) * 1000;
            }
            this.updateCredentials(name, credentials, true, true);
        };
        OpenapiAuthService.prototype.updateByCodeFlow = function (scheme, credentials, params) {
            return __awaiter(this, void 0, void 0, function () {
                var tokenUrl, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            tokenUrl = getTokenBaseUrl(scheme.securityScheme, 'authorizationCode');
                            _a = credentials;
                            return [4 /*yield*/, this.requestToken(tokenUrl, 'authorization_code', credentials, params.code).toPromise()];
                        case 1:
                            _a.token = _b.sent();
                            this.updateCredentials(name, credentials, true, true);
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Updates the provided credentials with a token
         */
        OpenapiAuthService.prototype.requestToken = function (tokenUrl, grantType, credentials, code) {
            var tokenRequest = {
                grant_type: grantType,
                client_id: credentials.clientId,
                client_secret: credentials.clientSecret
            };
            if (grantType === 'authorization_code') {
                tokenRequest.code = code;
                tokenRequest.redirect_uri = credentials.redirectUri;
            }
            if (grantType === 'password') {
                tokenRequest.username = credentials.username;
                tokenRequest.password = credentials.password;
            }
            if (!this.http) {
                throw new Error('No http client provider available.');
            }
            return this.http
                .post(tokenUrl, serializeQueryParams(tokenRequest), {
                headers: {
                    'Content-type': 'application/x-www-form-urlencoded'
                }
            })
                .pipe(operators.map(function (result) {
                if (result && result.access_token) {
                    var token = {
                        access_token: result.access_token,
                        token_type: result.token_type,
                        id_token: result.id_token,
                        refresh_token: result.refresh_token
                    };
                    if (result.expires_in) {
                        token.expires_at = new Date().getTime() + parseInt(result.expires_in, 10) * 1000;
                    }
                    return token;
                }
                else {
                    throw new Error('Missing access token in response from token endpoint ' + tokenUrl);
                }
            }));
        };
        OpenapiAuthService.prototype.removeToken = function (name) {
            var schema = this.getSchema(name);
            if (!schema || !schema.credentials) {
                return;
            }
            schema.credentials.token = null;
            schema.authenticated = false;
            writeCredentialsStore(name, schema.credentials);
            this.updatedCredentials.next(name);
        };
        OpenapiAuthService.ctorParameters = function () { return [
            { type: core.NgZone },
            { type: http.HttpClient, decorators: [{ type: core.Optional }] }
        ]; };
        OpenapiAuthService = __decorate([
            core.Injectable(),
            __param(1, core.Optional()),
            __metadata("design:paramtypes", [core.NgZone, http.HttpClient])
        ], OpenapiAuthService);
        return OpenapiAuthService;
    }());
    function clearCredentialsStore(name) {
        var key = getStorageKey(name);
        window.sessionStorage.removeItem(key);
    }
    function writeCredentialsStore(name, credentials) {
        var key = getStorageKey(name);
        var value = JSON.stringify(credentials);
        window.sessionStorage.setItem(key, value);
    }
    function readCredentialsStore(name) {
        var key = getStorageKey(name);
        var value = window.sessionStorage.getItem(key);
        if (typeof value === 'string') {
            try {
                return JSON.parse(value);
            }
            catch (e) {
                console.warn('Failed to parse credentials for ' + name, e);
            }
        }
        return null;
    }
    function getStorageKey(name) {
        return 'oavCredentials.' + name.replace(/[^-_A-Za-z0-9]/g, '_');
    }
    function getSecurityInformation(spec) {
        var e_3, _a;
        var securitySchemes = [];
        var definitions = spec.securityDefinitions || (spec.components && spec.components.securitySchemes) || {};
        try {
            for (var _b = __values(Object.entries(definitions)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), schemeName = _d[0], schemeDef = _d[1];
                var storedCredentials = readCredentialsStore(schemeName);
                securitySchemes.push({
                    name: schemeName,
                    securityScheme: schemeDef,
                    authenticated: storedCredentials !== null,
                    remember: storedCredentials !== null,
                    credentials: storedCredentials
                });
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return securitySchemes;
    }
    function identifyFlows(scheme) {
        var results = [];
        // V2
        if (scheme.flow) {
            var flowName = scheme.flow;
            if (flowName === 'application') {
                flowName = 'clientCredentials';
            }
            if (flowName === 'accessCode') {
                flowName = 'authorizationCode';
            }
            results.push({
                flow: flowName,
                scopes: toScopesInfo(scheme.scopes)
            });
        }
        if (scheme.flows) {
            if (scheme.flows.implicit) {
                results.push({
                    flow: 'implicit',
                    scopes: toScopesInfo(scheme.flows.implicit.scopes)
                });
            }
            if (scheme.flows.password) {
                results.push({
                    flow: 'password',
                    scopes: toScopesInfo(scheme.flows.password.scopes)
                });
            }
            if (scheme.flows.clientCredentials) {
                results.push({
                    flow: 'clientCredentials',
                    scopes: toScopesInfo(scheme.flows.clientCredentials.scopes)
                });
            }
            if (scheme.flows.authorizationCode) {
                results.push({
                    flow: 'authorizationCode',
                    scopes: toScopesInfo(scheme.flows.authorizationCode.scopes)
                });
            }
        }
        return results;
    }
    function toScopesInfo(scopes) {
        if (!scopes) {
            return [];
        }
        return Object.keys(scopes).map(function (name) { return ({ scope: name, description: scopes[name] }); });
    }
    function getAuthorizationBaseUrl(scheme, flow) {
        if (scheme.type === 'oauth2' && (scheme.flow === 'implicit' || scheme.flow === 'accessCode')) {
            return scheme.authorizationUrl;
        }
        if (scheme.type === 'oauth2' && scheme.flows && scheme.flows[flow]) {
            return scheme.flows[flow].authorizationUrl;
        }
        return null;
    }
    function getTokenBaseUrl(scheme, flow) {
        if (scheme.type === 'oauth2' && scheme.flow === 'accessCode') {
            return scheme.tokenUrl;
        }
        if (scheme.type === 'oauth2' && scheme.flows && scheme.flows[flow]) {
            return scheme.flows[flow].tokenUrl;
        }
        return null;
    }
    function buildAuthorizationUrl(scheme, credentials, state) {
        var baseUrl = getAuthorizationBaseUrl(scheme, credentials.flow);
        var params = {
            client_id: credentials.clientId,
            redirect_uri: credentials.redirectUri
        };
        if (credentials.flow === 'implicit') {
            params.response_type = 'token';
            params.nonce = credentials.nonce;
        }
        if (credentials.flow === 'authorizationCode') {
            params.response_type = 'code';
        }
        if (state) {
            params.state = state;
        }
        return baseUrl + '?' + serializeQueryParams(params);
    }

    var OpenapiViewerService = /** @class */ (function () {
        function OpenapiViewerService(http, authService) {
            this.http = http;
            this.authService = authService;
            this.spec = new rxjs.BehaviorSubject(null);
            this.tagIndex = new rxjs.BehaviorSubject([]);
            this.loadErrors = new rxjs.BehaviorSubject([]);
            this.operationParameterCache = {};
            this.requests = [];
            this.loadingPromise = null;
        }
        OpenapiViewerService.prototype.loadSpec = function (spec) {
            return this.resolveSpec({ spec: spec });
        };
        OpenapiViewerService.prototype.loadSpecByUrl = function (url) {
            return this.resolveSpec({ url: url });
        };
        OpenapiViewerService.prototype.resolveSpec = function (swaggerOpts) {
            return __awaiter(this, void 0, void 0, function () {
                var loadingPromise, resolveResult;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (this.loadErrors.value.length) {
                                this.loadErrors.next([]);
                            }
                            if (this.tagIndex.value.length) {
                                this.tagIndex.next([]);
                            }
                            this.loadingPromise = Swagger.resolve({ spec: swaggerOpts.spec, url: swaggerOpts.url });
                            loadingPromise = this.loadingPromise;
                            return [4 /*yield*/, loadingPromise];
                        case 1:
                            resolveResult = _a.sent();
                            if (loadingPromise !== this.loadingPromise) {
                                return [2 /*return*/, null];
                            }
                            this.spec.next(resolveResult.spec);
                            this.tagIndex.next(getTagIndex(resolveResult.spec));
                            this.authService.identifySchemes(resolveResult.spec);
                            this.operationParameterCache = {};
                            if (resolveResult.errors && resolveResult.errors.length) {
                                this.loadErrors.next(resolveResult.errors);
                                throw new Error('Spec resolve errors');
                            }
                            return [2 /*return*/, resolveResult.spec];
                    }
                });
            });
        };
        OpenapiViewerService.prototype.createRequest = function (operationId, parameters, requestBody, requestContentType, responseContentType) {
            // See https://github.com/swagger-api/swagger-js/blob/master/src/execute/index.js#L91
            var e_1, _a;
            var securities = {};
            try {
                for (var _b = __values(this.authService.securitySchemes.value), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var scheme = _c.value;
                    if (scheme.authenticated) {
                        securities[scheme.name] = scheme.credentials;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            var params = {
                spec: this.spec.value,
                operationId: operationId,
                parameters: parameters,
                securities: { authorized: securities },
                requestContentType: requestContentType,
                responseContentType: responseContentType,
                scheme: undefined,
                requestInterceptor: undefined,
                responseInterceptor: undefined,
                contextUrl: undefined,
                userFetch: undefined,
                requestBody: requestBody,
                server: undefined,
                serverVariables: undefined,
                http: undefined
            };
            return Swagger.buildRequest(params);
        };
        OpenapiViewerService.prototype.runRequest = function (pathItem, operationsItem, request) {
            var httpEvents = new rxjs.ReplaySubject(1);
            var reqInfo = {
                id: randomHex(8),
                pathItem: pathItem,
                operationsItem: operationsItem,
                request: request,
                running: true,
                canceled: false,
                sentBytes: 0,
                receivedBytes: 0,
                startTs: new Date(),
                endTs: null,
                httpEvents: httpEvents,
                statusText: null,
                status: 0,
                cancel: null
            };
            this.requests.push(reqInfo);
            var headers = new http.HttpHeaders(request.headers);
            var sub = this.http
                .request(new http.HttpRequest(request.method, request.url, request.body, {
                headers: headers,
                responseType: 'blob',
                reportProgress: true
            }))
                .subscribe(function (status) {
                if (status.type === http.HttpEventType.ResponseHeader || status.type === http.HttpEventType.Response) {
                    reqInfo.status = status.status;
                    reqInfo.statusText = status.statusText;
                }
                if (status.type === http.HttpEventType.UploadProgress) {
                    reqInfo.sentBytes = status.loaded;
                }
                if (status.type === http.HttpEventType.DownloadProgress) {
                    reqInfo.receivedBytes = status.loaded;
                }
                if (status.type === http.HttpEventType.Response) {
                    reqInfo.endTs = new Date();
                    reqInfo.running = false;
                }
                console.log('status', status);
                httpEvents.next(status);
            }, function (err) {
                reqInfo.endTs = new Date();
                reqInfo.running = false;
                httpEvents.error(err);
            }, function () {
                reqInfo.running = false;
                httpEvents.complete();
            });
            reqInfo.cancel = function () {
                sub.unsubscribe();
                reqInfo.canceled = true;
                reqInfo.running = false;
            };
            return reqInfo;
        };
        OpenapiViewerService.prototype.removeRequest = function (req) {
            this.requests.splice(this.requests.indexOf(req), 1);
        };
        OpenapiViewerService.prototype.getRequestsByOperationId = function (opId) {
            return this.requests.filter(function (req) { return req.operationsItem.operation.operationId === opId; });
        };
        OpenapiViewerService.prototype.saveOperationParameters = function (opId, parameters) {
            this.operationParameterCache[opId] = parameters;
        };
        OpenapiViewerService.prototype.loadOperationParameters = function (opId) {
            return this.operationParameterCache[opId];
        };
        OpenapiViewerService.prototype.resetSpec = function () {
            this.spec.next(null);
            this.tagIndex.next([]);
            this.loadErrors.next([]);
            this.requests = [];
            this.operationParameterCache = {};
        };
        OpenapiViewerService.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: OpenapiAuthService }
        ]; };
        OpenapiViewerService = __decorate([
            core.Injectable(),
            __metadata("design:paramtypes", [http.HttpClient, OpenapiAuthService])
        ], OpenapiViewerService);
        return OpenapiViewerService;
    }());
    function getTagIndex(spec) {
        return (spec.tags || [{ name: 'untagged' }]).map(function (tag) { return ({
            tag: tag,
            paths: getPathsByTag(spec, tag.name)
        }); });
    }
    function getPathsByTag(spec, tag) {
        var e_2, _a;
        var paths = Object.keys(spec.paths);
        var result = [];
        try {
            for (var paths_1 = __values(paths), paths_1_1 = paths_1.next(); !paths_1_1.done; paths_1_1 = paths_1.next()) {
                var path = paths_1_1.value;
                var pathObject = spec.paths[path];
                var tags = getTagsOfPath(pathObject);
                if ((tag !== 'untagged' && tags.includes(tag)) || (tag === 'untagged' && tags.length === 0)) {
                    var pathItem = {
                        path: path,
                        summary: pathObject.summary,
                        description: pathObject.description,
                        parameters: pathObject.parameters,
                        servers: pathObject.servers,
                        operations: null
                    };
                    pathItem.operations = getOperationsOfPath(pathObject, pathItem.parameters);
                    result.push(pathItem);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (paths_1_1 && !paths_1_1.done && (_a = paths_1.return)) _a.call(paths_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return result;
    }
    function getOperationsOfPath(pathObject, parentParameters) {
        var e_3, _a;
        var ops = [];
        try {
            for (var httpMethods_1 = __values(httpMethods), httpMethods_1_1 = httpMethods_1.next(); !httpMethods_1_1.done; httpMethods_1_1 = httpMethods_1.next()) {
                var method = httpMethods_1_1.value;
                var operation = pathObject[method];
                if (operation) {
                    if (!operation.operationId) {
                        operation.operationId = 'op-' + randomHex(8);
                    }
                    var parameters = [];
                    if (parentParameters) {
                        parameters.push.apply(parameters, __spread(parentParameters));
                    }
                    if (operation.parameters) {
                        parameters.push.apply(parameters, __spread(operation.parameters));
                    }
                    ops.push({
                        method: method,
                        operation: operation,
                        parameters: parameters,
                        responseTypes: identifyResponseTypes(operation)
                    });
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (httpMethods_1_1 && !httpMethods_1_1.done && (_a = httpMethods_1.return)) _a.call(httpMethods_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return ops;
    }
    function getTagsOfPath(pathObject) {
        var e_4, _a;
        var tags = [];
        try {
            for (var httpMethods_2 = __values(httpMethods), httpMethods_2_1 = httpMethods_2.next(); !httpMethods_2_1.done; httpMethods_2_1 = httpMethods_2.next()) {
                var method = httpMethods_2_1.value;
                var operation = pathObject[method];
                if (operation && operation.tags) {
                    tags.push.apply(tags, __spread(operation.tags));
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (httpMethods_2_1 && !httpMethods_2_1.done && (_a = httpMethods_2.return)) _a.call(httpMethods_2);
            }
            finally { if (e_4) throw e_4.error; }
        }
        return tags;
    }
    function identifyResponseTypes(operation) {
        var e_5, _a, e_6, _b;
        if (operation.produces) {
            return operation.produces;
        }
        var types = new Set();
        try {
            for (var _c = __values(Object.entries(operation.responses)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var _e = __read(_d.value, 2), status_1 = _e[0], res = _e[1];
                if (res.content) {
                    try {
                        for (var _f = (e_6 = void 0, __values(Object.keys(res.content))), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var contentType = _g.value;
                            types.add(contentType);
                        }
                    }
                    catch (e_6_1) { e_6 = { error: e_6_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                        }
                        finally { if (e_6) throw e_6.error; }
                    }
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_5) throw e_5.error; }
        }
        return __spread(types);
    }

    var OpenapiViewerComponent = /** @class */ (function () {
        function OpenapiViewerComponent(openApiService) {
            this.openApiService = openApiService;
            this.index = [];
            this.loading = false;
            this.error = null;
            this.loadErrors = [];
            this.destroy = new rxjs.Subject();
        }
        OpenapiViewerComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.openApiService.tagIndex.pipe(operators.takeUntil(this.destroy)).subscribe(function (tagIndex) {
                _this.index = tagIndex;
            });
            this.openApiService.loadErrors.pipe(operators.takeUntil(this.destroy)).subscribe(function (errors) {
                _this.loadErrors = errors;
            });
        };
        OpenapiViewerComponent.prototype.loadSpec = function (promise) {
            var _this = this;
            this.loading = true;
            this.error = null;
            return promise.then(function () {
                _this.error = null;
                _this.loading = false;
            }, function (e) {
                _this.loading = false;
                _this.error = e.message;
                console.error(e);
            });
        };
        OpenapiViewerComponent.prototype.ngOnDestroy = function () {
            this.destroy.complete();
        };
        OpenapiViewerComponent.prototype.ngOnChanges = function (changes) {
            if (changes.spec || changes.specUrl) {
                if (this.spec) {
                    this.loadSpec(this.openApiService.loadSpec(this.spec));
                }
                else if (this.specUrl) {
                    this.loadSpec(this.openApiService.loadSpecByUrl(this.specUrl));
                }
                else {
                    this.openApiService.resetSpec();
                }
            }
        };
        OpenapiViewerComponent.ctorParameters = function () { return [
            { type: OpenapiViewerService }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], OpenapiViewerComponent.prototype, "spec", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], OpenapiViewerComponent.prototype, "specUrl", void 0);
        OpenapiViewerComponent = __decorate([
            core.Component({
                selector: 'oav-openapi-viewer',
                template: "<div class=\"oav-layout\">\n  <header class=\"oav-header\">\n    <ng-content></ng-content>\n  </header>\n  <div class=\"oav-menu-header\">\n    <a href=\"javascript:\" class=\"oav-menu-toggle\" oavOpenable #openMenu=\"openable\"></a>\n  </div>\n  <div class=\"oav-content-container\">\n    <div *ngIf=\"loading\">\n      <span class=\"loading\"></span>\n      Loading\n    </div>\n\n    <div *ngIf=\"!loading && !index.length\">\n      No Tags found\n    </div>\n\n    <div *ngIf=\"!loading && error\">\n      <h3>Error</h3>\n      <pre>{{ error.toString() }}</pre>\n      <pre *ngFor=\"let err of loadErrors\">{{ err.toString() }}</pre>\n    </div>\n\n    <ng-container *ngIf=\"!loading && !error && index.length\">\n      <aside class=\"oav-index-container\" [class.open]=\"openMenu.open\">\n        <oav-index-nav [index]=\"index\"></oav-index-nav>\n      </aside>\n      <section class=\"oav-view-container\" [class.open]=\"openMenu.open\">\n        <router-outlet></router-outlet>\n      </section>\n    </ng-container>\n  </div>\n</div>\n",
                providers: [OpenapiAuthService, OpenapiViewerService],
                encapsulation: core.ViewEncapsulation.None,
                styles: ["@charset \"UTF-8\";.oav-layout{height:100vh;display:-webkit-box;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;flex-direction:column}.oav-layout .oav-menu-header{border-bottom:1px solid #ccc}.oav-layout .oav-menu-header .oav-menu-toggle{display:inline-block;color:#000;padding:.5rem;text-decoration:none;font-weight:700;font-size:1.2rem}.oav-layout .oav-menu-header .oav-menu-toggle::before{content:\"\u2630\"}.oav-layout .oav-content-container{-webkit-box-flex:1;flex:1;display:-webkit-box;display:flex;min-height:0;position:relative}.oav-layout .oav-content-container .oav-index-container{width:18rem;margin-left:-18rem;overflow:auto;background:#f6f6fb;-webkit-transition:margin-left .1s ease-out;transition:margin-left .1s ease-out}.oav-layout .oav-content-container .oav-index-container.open{margin-left:0}.oav-layout .oav-content-container .oav-view-container{-webkit-box-flex:1;flex:1;overflow:scroll;margin-right:0;-webkit-transition:margin-right .1s ease-out;transition:margin-right .1s ease-out}.oav-layout .oav-content-container .oav-view-container.open{margin-right:-18rem}.oav-content{margin:1rem}.oav-content h1{font-size:1.5em}.oav-content h3{font-size:1.15em}.oav-content h4{font-size:1em}.oav-content a{color:#2681ac}.oav-content a:hover{color:#31b1ff}.oav-content .deprecated{text-decoration:line-through}.oav-content .oav-path{font-family:monospace}.oav-content .oav-summary{font-weight:400}.oav-content .send-btn{color:#fff;background-color:#2681ac;font-size:1rem;padding:.5rem 1rem;border:0;margin:.2rem 0}.oav-content .send-btn:hover{background-color:#31b1ff}.oav-content .send-btn:disabled{background-color:#ccc}.oav-content pre{white-space:pre-wrap}.oav-content .oav-warning{color:#fb9200}.oav-content .ace_editor{border:1px solid #ccc}oav-json-schema .oav-json-schema-code{font-family:monospace}oav-json-schema .oav-json-schema-toggle{font-weight:700;text-decoration:none}oav-json-schema .json-schema-property{display:-webkit-box;display:flex;-webkit-box-align:start;align-items:flex-start}oav-json-schema .oav-json-schema-name.oav-json-schema-required::after{content:\"*\";color:#ac0003;padding-left:.1em}oav-json-schema .oav-json-schema-description{font-size:.9rem;margin-left:.5rem}oav-json-schema .oav-json-schema-description p{margin-top:0}oav-json-schema .oav-json-schema-description p:last-child{margin-bottom:0}oav-json-schema .oav-json-schema-type{margin-left:.2rem}oav-json-schema .oav-json-schema-type-name{color:#8a8a8f}.oav-method{width:5em;display:inline-block;color:#fff;text-align:center;padding:.2em;font-size:.7em}.oav-method.oav-method-get{background-color:#2681ac}.oav-method.oav-method-post{background-color:#25ac20}.oav-method.oav-method-put{background-color:#ac700e}.oav-method.oav-method-delete{background-color:#ac0003}.oav-method.oav-method-options{background-color:#ac03a6}.oav-method.oav-method-head{background-color:#87aaac}.oav-method.oav-method-trace{background-color:#87ac89}a.oav-header-link{color:#000;text-decoration:none}a.oav-header-link:hover{color:#2681ac}.oav-method-bg.method-get{background-color:rgba(38,129,172,.1)}.oav-method-bg.method-post{background-color:rgba(37,172,32,.1)}.oav-method-bg.method-put{background-color:rgba(172,112,14,.1)}.oav-method-bg.method-delete{background-color:rgba(172,0,3,.1)}.oav-method-bg.method-options{background-color:rgba(172,3,166,.1)}.oav-method-bg.method-head{background-color:rgba(135,170,172,.1)}.oav-method-bg.method-trace{background-color:rgba(135,172,137,.1)}oav-method-header h3{cursor:pointer;display:-webkit-box;display:flex;-webkit-box-align:center;align-items:center;padding:.5rem;margin:0}oav-method-header h3 .mainlink{text-decoration:inherit;color:inherit;cursor:pointer;font-size:1rem}oav-method-header h3 .method-get{background-color:#2681ac}oav-method-header h3 .method-post{background-color:#25ac20}oav-method-header h3 .method-put{background-color:#ac700e}oav-method-header h3 .method-delete{background-color:#ac0003}oav-method-header h3 .method-options{background-color:#ac03a6}oav-method-header h3 .method-head{background-color:#87aaac}oav-method-header h3 .method-trace{background-color:#87ac89}oav-method-header h3:hover{background-color:rgba(135,172,137,.2)}oav-method-header h3 .path{font-family:monospace;font-size:1.2rem}oav-method-header h3 .summary{padding:0 10px;font-size:.8rem;font-weight:400;-webkit-box-flex:1;flex:1}oav-method-header h3 .summary.extra-link{-webkit-box-flex:0;flex:none}.openapi-operation{margin:.5rem 0}.openapi-operation .oav-operation-details{display:none}.openapi-operation.open{padding-bottom:1rem}.openapi-operation.open .oav-operation-details{display:block}.openapi-operation.deprecated h3 .mainlink{text-decoration:line-through}.oav-operation-details{margin:.5rem 0;padding:0 2rem}.oav-operation-details .send-btn{color:#fff;background-color:#2681ac;font-size:1rem;padding:.5rem 1rem;border:0;margin:.2rem 0}.oav-operation-details .send-btn:hover{background-color:#31b1ff}.oav-operation-details pre{white-space:pre-wrap}.oav-operation-details h4{background-color:rgba(255,255,255,.6);padding:.5rem 2rem;margin:.5rem -2rem}.oav-operation-layout{display:-webkit-box;display:flex}.oav-operation-layout .oav-operation-details{-webkit-box-flex:1;flex:1}.oav-operation-layout .oav-operation-requests{min-width:30rem;margin-left:1rem}@media (max-width:80rem){.oav-operation-layout{display:block}.oav-operation-layout .oav-operation-requests{margin-left:0}}.toggle-button{border:none;background:0 0;outline:0}.toggle-button:before{font-size:1rem;font-weight:600;content:\"\u3009\";display:inline-block;-webkit-transform-origin:25% 50%;transform-origin:25% 50%;-webkit-transition:-webkit-transform .2s ease-out;transition:transform .2s ease-out;transition:transform .2s ease-out,-webkit-transform .2s ease-out}.toggle-button.open:before{-webkit-transform:rotate(90deg);transform:rotate(90deg)}.toggle-button.full-rotate.open:before{-webkit-transform:rotate(180deg);transform:rotate(180deg)}.download-btn{color:#fff;background-color:#2681ac;font-size:1rem;padding:.5rem 1rem;border:0;margin:.2rem 0}.download-btn:hover{background-color:#31b1ff}.dismiss-btn{color:#fff;background-color:#ac0003;font-size:1rem;padding:.5rem 1rem;border:0;margin:.2rem 0}.dismiss-btn:hover{background-color:#d60003}.oav-parameter{border-bottom:1px solid #ccc;padding:.2rem 0;box-sizing:border-box}.oav-parameter .input,.oav-parameter .name{margin:.2rem 0;padding-right:.5rem}.oav-parameter .input input:not([type=checkbox]),.oav-parameter .input select,.oav-parameter .input textarea{width:100%;padding:.2rem;font-size:1rem;font-family:monospace;box-sizing:border-box}.oav-parameter .input textarea{min-height:10em}.oav-parameter .description{margin:.2rem 0}.oav-parameter .description p{margin-top:0}.oav-parameter .description p:last-child{margin-bottom:0}.oav-parameter .required{color:#ac0003}.oav-parameter .format,.oav-parameter .param-in{color:#828282;font-size:.8rem}.multi-item-entry{display:-webkit-box;display:flex;margin-bottom:.2rem}.multi-item-entry input{padding:.2rem;font-size:1rem;font-family:monospace;box-sizing:border-box}.multi-item-entry button{color:#fff;background-color:#a7a7ac;font-size:1rem;padding:.2rem 1rem;border:0;min-width:2.6rem;margin-left:.2rem}.multi-item-entry button:hover{background-color:#d4d4d9}.oav-add-btn{color:#fff;background-color:#a7a7ac;font-size:1rem;padding:.2rem 1rem;border:0;min-width:2.6rem}.oav-add-btn:hover{background-color:#d4d4d9}.oav-btn-container{text-align:right}.oav-divided-container .main{-webkit-box-flex:1;flex:1}.oav-auth-status{font-family:monospace;cursor:pointer}.oav-auth-status::before{content:\" \"}.oav-auth-status.required::before{content:\"\uD83D\uDD12\uFE0E\";color:#8a8a8f}.oav-auth-status.ok::before{content:\"\uD83D\uDD13\uFE0E\";color:#25ac20}.oav-request{background:#f1f1f1;margin:.5rem 0}.oav-request.method-get{background-color:rgba(38,129,172,.1)}.oav-request.method-get h3:hover{background-color:rgba(38,129,172,.2)}.oav-request.method-post{background-color:rgba(37,172,32,.1)}.oav-request.method-post h3:hover{background-color:rgba(37,172,32,.2)}.oav-request.method-put{background-color:rgba(172,112,14,.1)}.oav-request.method-put h3:hover{background-color:rgba(172,112,14,.2)}.oav-request.method-delete{background-color:rgba(172,0,3,.1)}.oav-request.method-delete h3:hover{background-color:rgba(172,0,3,.2)}.oav-request.method-options{background-color:rgba(172,3,166,.1)}.oav-request.method-options h3:hover{background-color:rgba(172,3,166,.2)}.oav-request.method-head{background-color:rgba(135,170,172,.1)}.oav-request.method-head h3:hover{background-color:rgba(135,170,172,.2)}.oav-request.method-trace{background-color:rgba(135,172,137,.1)}.oav-request.method-trace h3:hover{background-color:rgba(135,172,137,.2)}.oav-request h4{background-color:rgba(255,255,255,.6);padding:.5rem 2rem;margin:.5rem -2rem}.oav-request .content{padding:1rem}.oav-request textarea{font-family:monospace;white-space:pre-wrap;box-sizing:border-box;background:#fff;width:100%;min-height:5rem}.oav-request .status-200,.oav-request .status-201,.oav-request .status-202,.oav-request .status-204{color:#25ac20}.oav-request .status-400,.oav-request .status-401,.oav-request .status-402,.oav-request .status-403,.oav-request .status-404,.oav-request .status-405,.oav-request .status-406,.oav-request .status-500,.oav-request .status-501,.oav-request .status-503,.oav-request .status-504,.oav-request .status-505{color:#ac0003}.oav-tab-nav{border-bottom:1px solid #ccc}.oav-tab-nav a{color:#000;display:inline-block;text-decoration:none;padding:.5rem 1rem}.oav-tab-nav a.active,.oav-tab-nav a:hover{color:#2681ac}.oav-tab-nav a.active{padding-bottom:.3rem;border-bottom:.2rem solid #2681ac}.oav-index-nav{padding:0 0 1rem;font-size:.8rem}.oav-index-nav .deprecated{text-decoration:line-through}.oav-index-nav header a{color:#000;text-decoration:none;padding:.2em 1rem;font-size:1rem;display:-webkit-box;display:flex;-webkit-box-pack:justify;justify-content:space-between;font-weight:700}.oav-index-nav header a:hover{color:#2681ac;background:#fff}.oav-index-nav ol{padding-left:0}.oav-index-nav li{padding:0;display:block}.oav-index-nav li oav-method{margin-right:.5em}.oav-index-nav li a{color:#000;text-decoration:none;padding:.2em .2em .2em 1rem;box-sizing:border-box;display:block;position:relative}.oav-index-nav li a .label{display:-webkit-box;display:flex}.oav-index-nav li a .info-overlay{padding:.2em .2em .2em 1rem;display:none;position:absolute;background:#fff;top:0;left:0;white-space:nowrap}.oav-index-nav li a:hover{background:#fff;color:#2681ac}.oav-index-nav li a:hover .info-overlay{display:-webkit-box;display:flex}.oav-index-nav li a:hover .label{visibility:hidden}.oav-index-nav li a.active,.oav-index-nav li a:active{background:#fff;font-weight:700;color:#2681ac}.oav-index-nav .oav-bottom-nav,.oav-index-nav .oav-top-nav{border-bottom:1px solid #ccc;margin:.5rem 0;padding:.5rem 0}.oav-index-nav .oav-bottom-nav a,.oav-index-nav .oav-top-nav a{font-size:1rem;padding-left:1rem}.oav-index-nav .oav-bottom-nav{border-bottom:0;border-top:1px solid #ccc}.m-0{margin:0}.my-0{margin-top:0;margin-bottom:0}.my-3{margin-top:1rem;margin-bottom:1rem}.mt-0{margin-top:0}.ml-auto{margin-left:auto}.ml-0{margin-left:0!important}.ml-1{margin-left:.25rem}.ml-2{margin-left:.5rem}.ml-3{margin-left:1rem}.font-size-tiny{font-size:.5rem}.font-size-smaller{font-size:.8rem}.font-size-1{font-size:1rem}.font-size-2{font-size:2rem}.font-size-3{font-size:3rem}.d-flex{display:-webkit-box;display:flex}.align-items-center{-webkit-box-align:center;align-items:center}.flex-grow-1{-webkit-box-flex:1;flex:1}.justify-content-between{-webkit-box-pack:justify;justify-content:space-between}.normal-text{font-size:1rem;font-weight:400}.oav-error{color:#ac0003}.openable{cursor:pointer}.loading:before{content:\"\u21BB\";display:inline-block;-webkit-animation:2s linear infinite spin-loader;animation:2s linear infinite spin-loader}oav-tooltip{display:block;background:#fff;border:1px solid #ccc;padding:1rem;box-shadow:0 0 3px #ccc}@-webkit-keyframes spin-loader{to{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes spin-loader{to{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.openapi-response{border-bottom:1px solid #ccc;padding:.2rem 0;box-sizing:border-box}.openapi-response .status-code{margin:.2rem 0;padding-right:.5rem}.openapi-response .description{margin:.2rem 0}@media (min-width:60rem){.d-md-flex{display:-webkit-box;display:flex}.oav-layout .oav-menu-header{display:none}.oav-layout .oav-content-container .oav-index-container{margin-left:0}.oav-layout .oav-content-container .oav-view-container.open{margin-right:0}.oav-parameter{display:-webkit-box;display:flex}.oav-parameter .name{width:15rem}.oav-parameter .description,.oav-parameter .input{width:50%}.openapi-response{display:-webkit-box;display:flex}.openapi-response .status-code{width:15rem}.openapi-response .description{min-width:30rem}.oav-divided-container{display:-webkit-box;display:flex}}"]
            }),
            __metadata("design:paramtypes", [OpenapiViewerService])
        ], OpenapiViewerComponent);
        return OpenapiViewerComponent;
    }());

    var OavSettings = /** @class */ (function () {
        function OavSettings(overwriteSettings) {
            /**
             * Which value of an operation is shown in the index navigation, in which order.
             * The first one is displayed if available, otherwise the nex one will be  chosen until a value is available.
             */
            this.indexPrimaryLabel = ['summary', 'operationId', 'path'];
            /**
             * Which value is shown in the index navigation on hover.
             */
            this.indexHoverLabel = ['path'];
            /**
             * Which value of an operation is shown in the overview navigation, in which order.
             * The first one is displayed if available, otherwise the nex one will be  chosen until a value is available.
             */
            this.overviewPrimaryLabel = ['summary', 'operationId'];
            /**
             * Whether to show the option to display the raw operation definition on the operation page.
             */
            this.showRawOperationDefinition = false;
            /**
             * Show raw model definitions
             */
            this.showRawModelDefinition = false;
            /**
             * Whether authentication is enabled.
             * - Status is shown at operations
             * - Authentication page is shown, where a user can enter credentials
             */
            this.enableAuthentication = true;
            /**
             * Show the models overview page
             */
            this.enableModelsOverview = true;
            if (overwriteSettings) {
                Object.assign(this, overwriteSettings);
            }
        }
        return OavSettings;
    }());
    var defaultOavSettings = new OavSettings();

    var OperationComponent = /** @class */ (function () {
        function OperationComponent(openApiService, oavSettings, authService, cd) {
            this.openApiService = openApiService;
            this.oavSettings = oavSettings;
            this.authService = authService;
            this.cd = cd;
            this.responseType = new forms.FormControl('application/json');
            this.requests = [];
            this.openRequest = null;
            this.showRawOperationDefinition = false;
            this.showAuthentication = true;
            if (!this.oavSettings) {
                this.oavSettings = defaultOavSettings;
            }
            this.showRawOperationDefinition = this.oavSettings.showRawOperationDefinition;
            this.showAuthentication = this.oavSettings.enableAuthentication;
        }
        Object.defineProperty(OperationComponent.prototype, "operation", {
            get: function () {
                return this.operationItem.operation;
            },
            enumerable: true,
            configurable: true
        });
        OperationComponent.prototype.ngOnChanges = function (changes) {
            if (changes.operationItem && this.operationItem) {
                if (changes.operationItem.previousValue && this.formGroup) {
                    var prevOperation = changes.operationItem.previousValue;
                    this.openApiService.saveOperationParameters(prevOperation.operation.operationId, this.formGroup.value);
                }
                this.requests = this.openApiService.getRequestsByOperationId(this.operationItem.operation.operationId).reverse();
                this.formGroup = new forms.FormGroup({ __responseType: this.responseType });
                this.responseType.patchValue(this.operationItem.responseTypes[0] || 'application/json');
                this.authStatus = this.authService.getAuthStatus(this.operationItem.operation.security);
                var savedParams = this.openApiService.loadOperationParameters(this.operation.operationId);
                if (savedParams) {
                    this.cd.detectChanges();
                    this.formGroup.patchValue(savedParams);
                }
            }
        };
        OperationComponent.prototype.ngOnDestroy = function () {
            if (this.operationItem) {
                this.openApiService.saveOperationParameters(this.operation.operationId, this.formGroup.value);
            }
        };
        OperationComponent.prototype.send = function () {
            try {
                var parameters = __assign({}, this.formGroup.value);
                var requestBody = void 0;
                var contentType = '';
                if (parameters.requestBody) {
                    contentType = parameters.requestBody.contentType;
                    requestBody = __assign({}, parameters.requestBody);
                    delete requestBody.contentType;
                    delete parameters.requestBody;
                }
                var req = this.openApiService.createRequest(this.operationItem.operation.operationId, parameters, requestBody, contentType, this.responseType.value);
                var reqInfo = this.openApiService.runRequest(this.pathItem, this.operationItem, req);
                this.requests.unshift(reqInfo);
                this.openRequest = reqInfo;
            }
            catch (e) {
                console.warn('Create request error', e);
            }
        };
        OperationComponent.ctorParameters = function () { return [
            { type: OpenapiViewerService },
            { type: OavSettings, decorators: [{ type: core.Optional }] },
            { type: OpenapiAuthService },
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], OperationComponent.prototype, "tag", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], OperationComponent.prototype, "pathItem", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], OperationComponent.prototype, "operationItem", void 0);
        OperationComponent = __decorate([
            core.Component({
                selector: 'oav-operation',
                template: "<h1>\n  <oav-method [method]=\"operationItem.method\"></oav-method>\n  <oav-auth-status [operation]=\"operationItem.operation\"></oav-auth-status>\n  <span class=\"oav-path ml-1\" [class.deprecated]=\"operation.deprecated\">{{ pathItem.path }}</span>\n  <span class=\"oav-summary font-size-smaller ml-2\">{{ operation.summary }}</span>\n</h1>\n\n<p *ngIf=\"operationItem.operation.description\">\n  <markdown [data]=\"operationItem.operation.description\"></markdown>\n</p>\n\n<form (submit)=\"send()\" [formGroup]=\"formGroup\">\n  <ng-container *ngIf=\"operationItem.parameters?.length\">\n    <h3>Parameters</h3>\n    <oav-parameter *ngFor=\"let param of operationItem.parameters\" [parameter]=\"param\" [formGroup]=\"formGroup\"></oav-parameter>\n  </ng-container>\n  <ng-container *ngIf=\"operationItem.operation.requestBody\">\n    <oav-request-body-input [requestBody]=\"operationItem.operation.requestBody\" [addToFormGroup]=\"formGroup\"></oav-request-body-input>\n  </ng-container>\n  <div *ngIf=\"operationItem.responseTypes?.length > 1\">\n    <div class=\"oav-parameter\">\n      <div class=\"name\">\n        <div><strong>Response type</strong>:</div>\n        <div class=\"param-in\">\n          Accept header\n        </div>\n      </div>\n      <div class=\"input\">\n        <select [formControl]=\"responseType\">\n          <option *ngFor=\"let resType of operationItem.responseTypes\" [value]=\"resType\">{{ resType }}</option>\n        </select>\n      </div>\n      <div class=\"description\"></div>\n    </div>\n  </div>\n  <button class=\"send-btn\" [disabled]=\"formGroup.invalid\">Send request</button>\n</form>\n\n<h3 oavOpenable #responseOpenable=\"openable\" class=\"toggle-button\">Responses</h3>\n\n<oav-responses\n  *ngIf=\"responseOpenable.open\"\n  [responses]=\"operationItem.operation.responses\"\n  [responseType]=\"responseType.value\"\n></oav-responses>\n\n<div class=\"oav-operation-requests\" [hidden]=\"!requests.length\">\n  <h3>Requests</h3>\n  <oav-requests-list [requests]=\"requests\" [openRequest]=\"openRequest\"></oav-requests-list>\n</div>\n\n<ng-container *ngIf=\"showRawOperationDefinition\">\n  <h3 oavOpenable #rawOpenable=\"openable\" class=\"toggle-button\">Raw operation definition</h3>\n  <oav-code-input *ngIf=\"rawOpenable.open\" mode=\"json\" [ngModel]=\"operationItem.operation | json\" readonly></oav-code-input>\n</ng-container>\n"
            }),
            __param(1, core.Optional()),
            __metadata("design:paramtypes", [OpenapiViewerService,
                OavSettings,
                OpenapiAuthService,
                core.ChangeDetectorRef])
        ], OperationComponent);
        return OperationComponent;
    }());

    var primitiveTypes = ['string', 'integer', 'number', 'boolean'];
    var ɵ0$1 = function (param) { return param.type === 'string' && param.items && param.items.enum; }, ɵ1$1 = function (param) { return schemaType(param) === 'string' && param.schema.enum; }, ɵ2$1 = function (param, mediaType) { return getExample(param, mediaType); }, ɵ3$1 = function (param) { return param.type === 'string'; }, ɵ4$1 = function (param) { return schemaType(param) === 'string'; }, ɵ5$1 = function (param, mediaType) { return getExample(param, mediaType); }, ɵ6$1 = function (param) { return param.type === 'integer'; }, ɵ7$1 = function (param) { return schemaType(param) === 'integer'; }, ɵ8$1 = function (param, mediaType) { return getExample(param, mediaType); }, ɵ9$1 = function (param) { return param.type === 'object'; }, ɵ10$1 = function (param) { return schemaType(param) === 'object' || (param.schema && param.schema.properties); }, ɵ11$1 = function (param, mediaType) { return getExample(param, mediaType); }, ɵ12$1 = function (param) { return param.type === 'array' && param.items && param.items.enum; }, ɵ13$1 = function (param) { return schemaType(param) === 'array' && param.schema.enum; }, ɵ14$1 = function (param, mediaType) { return getExample(param, mediaType); }, ɵ15 = function (param) { return param.type === 'array' && primitiveTypes.includes(itemsType(param)); }, ɵ16 = function (param) { return schemaType(param) === 'array' && primitiveTypes.includes(itemsType(param.schema)); }, ɵ17 = function (param, mediaType) { return getExample(param, mediaType); }, ɵ18 = function (param) { return param.type === 'array'; }, ɵ19 = function (param) { return schemaType(param) === 'array'; }, ɵ20 = function (param, mediaType) { return getExample(param, mediaType); }, ɵ21 = function (param) { return param.type === 'file'; }, ɵ22 = function (param) { return false; }, ɵ23 = function (param, mediaType) { return ''; }, ɵ24 = function (param) { return true; }, ɵ25 = function (param) { return true; }, ɵ26 = function (param, mediaType) { return ''; };
    var displayModes = [
        {
            mode: 'textSelect',
            checkV2: ɵ0$1,
            checkV3: ɵ1$1,
            getDefault: ɵ2$1
        },
        {
            mode: 'text',
            checkV2: ɵ3$1,
            checkV3: ɵ4$1,
            getDefault: ɵ5$1
        },
        {
            mode: 'integer',
            checkV2: ɵ6$1,
            checkV3: ɵ7$1,
            getDefault: ɵ8$1
        },
        {
            mode: 'object',
            checkV2: ɵ9$1,
            checkV3: ɵ10$1,
            getDefault: ɵ11$1
        },
        {
            mode: 'arrayWithSelection',
            checkV2: ɵ12$1,
            checkV3: ɵ13$1,
            getDefault: ɵ14$1
        },
        {
            mode: 'arrayWithPrimitive',
            checkV2: ɵ15,
            checkV3: ɵ16,
            getDefault: ɵ17
        },
        {
            mode: 'array',
            checkV2: ɵ18,
            checkV3: ɵ19,
            getDefault: ɵ20
        },
        {
            mode: 'file',
            checkV2: ɵ21,
            checkV3: ɵ22,
            getDefault: ɵ23
        },
        {
            mode: 'any',
            checkV2: ɵ24,
            checkV3: ɵ25,
            getDefault: ɵ26
        }
    ];
    function schemaType(param) {
        var schema = param && 'schema' in param ? param.schema : null;
        return schema && schema.type;
    }
    function itemsType(obj) {
        if (obj && Array.isArray(obj.items)) {
            return obj.items[0].type;
        }
        else if (obj && obj.items) {
            return obj.items.type;
        }
        console.warn('items type not found', obj);
    }
    function getExample(param, mediaType) {
        if (param.example !== undefined) {
            return param.example;
        }
        if (param.examples !== undefined && param.examples[mediaType] && 'value' in param.examples[mediaType]) {
            return param.examples[mediaType].value;
        }
        if (param.schema) {
            return exampleFromSchema(param.schema);
        }
        if (param.type === 'array' && param.items && 'default' in param.items) {
            return [param.items.default];
        }
        if (isPrimitiveType(param.type) && param.items && 'default' in param.items) {
            return param.items.default;
        }
        return exampleFromSchema(param);
    }
    function getDisplayMode(param) {
        var e_1, _a;
        try {
            for (var displayModes_1 = __values(displayModes), displayModes_1_1 = displayModes_1.next(); !displayModes_1_1.done; displayModes_1_1 = displayModes_1.next()) {
                var dm = displayModes_1_1.value;
                if ('type' in param && dm.checkV2(param)) {
                    return dm.mode;
                }
                else if (dm.checkV3(param)) {
                    return dm.mode;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (displayModes_1_1 && !displayModes_1_1.done && (_a = displayModes_1.return)) _a.call(displayModes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return 'any';
    }
    function getExampleValue(displayMode, param, mediaType) {
        return displayModes.find(function (dm) { return dm.mode === displayMode; }).getDefault(param, mediaType);
    }
    function isPrimitiveType(type) {
        return ['number', 'boolean', 'string', 'integer'].includes(type);
    }

    var ParameterComponent = /** @class */ (function () {
        function ParameterComponent() {
            this.mediaType = '';
            this.displayMode = 'any';
            this.enum = null;
        }
        ParameterComponent.prototype.ngOnChanges = function (changes) {
            this.displayMode = getDisplayMode(this.parameter);
            this.value = getExampleValue(this.displayMode, this.parameter, this.mediaType);
            if (this.displayMode === 'object' || this.displayMode === 'array') {
                this.value = JSON.stringify(this.value, null, 2);
            }
            var validators = [];
            if (this.parameter.required) {
                validators.push(forms.Validators.required);
            }
            this.control = new forms.FormControl(this.value, validators);
            if (this.formGroup) {
                this.formGroup.addControl(this.parameter.name, this.control);
            }
            this.enum =
                (this.parameter.items && this.parameter.items.enum) || (this.parameter.schema && this.parameter.schema.enum);
        };
        ParameterComponent.prototype.ngOnDestroy = function () {
            if (this.formGroup) {
                this.formGroup.removeControl(this.parameter.name);
            }
        };
        __decorate([
            core.Input(),
            __metadata("design:type", forms.FormGroup)
        ], ParameterComponent.prototype, "formGroup", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], ParameterComponent.prototype, "parameter", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], ParameterComponent.prototype, "mediaType", void 0);
        ParameterComponent = __decorate([
            core.Component({
                selector: 'oav-parameter',
                template: "<div class=\"oav-parameter\" [formGroup]=\"formGroup\">\n  <div class=\"name\">\n    <div>\n      <strong>{{ parameter.name }}</strong\n      ><span class=\"required\" *ngIf=\"parameter.required\" title=\"required\">*</span>:\n      <span class=\"type\">{{ parameter.type }}</span>\n    </div>\n    <div class=\"param-in\">\n      {{ parameter.customIn ? parameter.customIn : parameter.in }}\n      <span class=\"format\" *ngIf=\"parameter.format\">({{ parameter.format }})</span>\n    </div>\n  </div>\n  <div class=\"input\">\n    <ng-container *ngIf=\"displayMode === 'textSelect'\">\n      <select [formControlName]=\"parameter.name\" [name]=\"parameter.name\">\n        <option *ngFor=\"let opt of enum\" [value]=\"opt\">{{ opt }}</option>\n      </select>\n    </ng-container>\n\n    <ng-container *ngIf=\"displayMode === 'text'\">\n      <input [formControlName]=\"parameter.name\" [placeholder]=\"parameter.name\" [name]=\"parameter.name\" />\n    </ng-container>\n\n    <ng-container *ngIf=\"displayMode === 'integer'\">\n      <input type=\"number\" [formControlName]=\"parameter.name\" [placeholder]=\"parameter.name\" [name]=\"parameter.name\" />\n    </ng-container>\n\n    <ng-container *ngIf=\"displayMode === 'number'\">\n      <input type=\"number\" [formControlName]=\"parameter.name\" [placeholder]=\"parameter.name\" [name]=\"parameter.name\" />\n    </ng-container>\n\n    <ng-container *ngIf=\"displayMode === 'file'\">\n      <input type=\"file\" [formControlName]=\"parameter.name\" [placeholder]=\"parameter.name\" [name]=\"parameter.name\" />\n    </ng-container>\n\n    <ng-container *ngIf=\"displayMode === 'object' || displayMode === 'array'\">\n      <oav-code-input [formControlName]=\"parameter.name\" mode=\"json\" [schema]=\"parameter.schema\"></oav-code-input>\n    </ng-container>\n\n    <ng-container *ngIf=\"displayMode === 'arrayWithSelection'\">\n      <select [formControlName]=\"parameter.name\" [name]=\"parameter.name\" multiple>\n        <option *ngFor=\"let opt of enum\" [ngValue]=\"opt\">{{ opt }}</option>\n      </select>\n    </ng-container>\n\n    <ng-container *ngIf=\"displayMode === 'arrayWithPrimitive'\">\n      <oav-multi-items-input [formControlName]=\"parameter.name\"></oav-multi-items-input>\n    </ng-container>\n  </div>\n  <div class=\"description\">\n    <markdown [data]=\"parameter.description\"></markdown>\n\n    <ng-container *ngIf=\"displayMode === 'object' || displayMode === 'array'\">\n      <oav-json-schema [schema]=\"parameter.schema\"></oav-json-schema>\n    </ng-container>\n  </div>\n</div>\n"
            }),
            __metadata("design:paramtypes", [])
        ], ParameterComponent);
        return ParameterComponent;
    }());

    var ResponsesComponent = /** @class */ (function () {
        function ResponsesComponent() {
            this.items = [];
            this.mode = 'text';
        }
        ResponsesComponent.prototype.ngOnChanges = function (changes) {
            if (!this.responses) {
                return;
            }
            if (this.responseType && this.responseType.startsWith('application/json')) {
                this.mode = 'json';
            }
            else if (this.responseType && this.responseType.startsWith('application/xml')) {
                this.mode = 'xml';
            }
            else {
                this.mode = 'text';
            }
            this.items = getExamplesByContentType(this.responses, this.responseType);
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], ResponsesComponent.prototype, "responses", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], ResponsesComponent.prototype, "responseType", void 0);
        ResponsesComponent = __decorate([
            core.Component({
                selector: 'oav-responses',
                template: "<oav-tab-nav>\n  <ng-container *ngFor=\"let status of items\">\n    <div *oavTabNavItem=\"status.statusCode\">\n      <markdown *ngIf=\"status.description\" [data]=\"status.description\"></markdown>\n      <ng-container *ngIf=\"status.headers?.length\">\n        <h4>Example Headers</h4>\n        <div class=\"my-3\">\n          <div class=\"oav-parameter\" *ngFor=\"let header of status.headers\">\n            <div class=\"name\">{{ header.name }}:</div>\n            <div class=\"input\">{{ header.value }}</div>\n            <div class=\"description\">\n              <markdown [data]=\"header.description\"></markdown>\n            </div>\n          </div>\n        </div>\n      </ng-container>\n      <ng-container *ngIf=\"status.contents?.length === 1\">\n        <h4>Example Body</h4>\n        <div class=\"oav-divided-container\">\n          <div class=\"flex-grow-1\">\n            <oav-code-input readonly [ngModel]=\"status.contents[0].value\" [mode]=\"mode\"></oav-code-input>\n          </div>\n          <div *ngIf=\"status.contents[0].schema\" class=\"flex-grow-1 ml-3\">\n            <oav-json-schema [schema]=\"status.contents[0].schema\"></oav-json-schema>\n          </div>\n        </div>\n      </ng-container>\n      <ng-container *ngIf=\"status.contents?.length > 1\">\n        <oav-tab-nav>\n          <ng-container *ngFor=\"let content of status.contents\">\n            <div *oavTabNavItem=\"content.summary || content.name\">\n              <markdown *ngIf=\"content.description\" [data]=\"content.description\"></markdown>\n              <a *ngIf=\"content.externalValueUrl\" [href]=\"content.externalValueUrl\" target=\"_blank\">Example</a>\n              <div class=\"oav-divided-container\" *ngIf=\"!content.externalValueUrl\">\n                <div class=\"flex-grow-1\">\n                  <oav-code-input readonly [ngModel]=\"content.value\" [mode]=\"mode\" [maxLines]=\"20\"></oav-code-input>\n                </div>\n                <div *ngIf=\"content.schema\" class=\"flex-grow-1 ml-3\">\n                  <oav-json-schema [schema]=\"content.schema\"></oav-json-schema>\n                </div>\n              </div>\n            </div>\n          </ng-container>\n        </oav-tab-nav>\n      </ng-container>\n    </div>\n  </ng-container>\n</oav-tab-nav>\n"
            }),
            __metadata("design:paramtypes", [])
        ], ResponsesComponent);
        return ResponsesComponent;
    }());
    function getExamplesByContentType(responses, contentType) {
        return Object.keys(responses).map(function (statusCode) {
            var res = responses[statusCode];
            return {
                statusCode: statusCode,
                description: res.description,
                headers: getExampleHeaders(res.headers),
                contents: getExampleContents(res, contentType)
            };
        });
    }
    function getExampleContents(res, contentType) {
        if (res.schema) {
            return [
                {
                    value: JSON.stringify(exampleFromSchema(res.schema), null, 2),
                    schema: res.schema
                }
            ];
        }
        if (!res.content) {
            return [];
        }
        var content = res.content[contentType];
        if (!content) {
            var mediaType = Object.keys(res.content).find(function (mt) { return getStarMatcher(mt).test(contentType); });
            if (mediaType) {
                content = res.content[mediaType];
            }
        }
        if (!content) {
            return [];
        }
        if (content.example && contentType.includes('json')) {
            return [{ value: getJsonString(content.example) }];
        }
        if (content.examples) {
            return Object.keys(content.examples).map(function (exName) {
                var example = content.examples[exName];
                return {
                    name: exName,
                    summary: example.summary,
                    description: example.description,
                    value: getJsonString(example.value),
                    externalValueUrl: example.externalValue
                };
            });
        }
        if (content.schema) {
            return [
                {
                    value: JSON.stringify(exampleFromSchema(content.schema), null, 2),
                    schema: content.schema
                }
            ];
        }
        return [];
    }
    function getExampleHeaders(headers) {
        if (!headers) {
            return [];
        }
        return Object.keys(headers).map(function (headerName) {
            var header = headers[headerName];
            return {
                name: headerName,
                description: header.description,
                deprecated: header.deprecated,
                value: getHeaderExampleValue(header)
            };
        });
    }
    function getHeaderExampleValue(headerObject) {
        var displayMode = getDisplayMode(headerObject);
        return getExampleValue(displayMode, headerObject, null);
    }

    var MultiItemsInputComponent = /** @class */ (function () {
        function MultiItemsInputComponent() {
            this.disabled = false;
            this.values = new forms.FormArray([]);
            this.onChange = function (v) { };
            this.onTouched = function () { };
        }
        MultiItemsInputComponent_1 = MultiItemsInputComponent;
        MultiItemsInputComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription = this.values.valueChanges.subscribe(function (changedValues) {
                _this.onChange(changedValues);
                _this.onTouched();
            });
            var controls = {};
            controls[this.name] = this.values;
            this.formGroup = new forms.FormGroup(controls);
        };
        Object.defineProperty(MultiItemsInputComponent.prototype, "isRequired", {
            get: function () {
                return typeof this.required !== 'undefined' || this.required === true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MultiItemsInputComponent.prototype, "controls", {
            get: function () {
                return this.values.controls;
            },
            enumerable: true,
            configurable: true
        });
        MultiItemsInputComponent.prototype.ngOnDestroy = function () {
            if (this.subscription) {
                this.subscription.unsubscribe();
            }
        };
        MultiItemsInputComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        MultiItemsInputComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        MultiItemsInputComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
            if (this.disabled) {
                this.values.disable();
            }
            else {
                this.values.enable();
            }
        };
        MultiItemsInputComponent.prototype.writeValue = function (obj) {
            var _this = this;
            if (obj) {
                this.values.clear();
                obj.forEach(function (value) { return _this.values.push(new forms.FormControl({ value: value, disabled: _this.disabled })); });
            }
            else {
                this.values.clear();
            }
        };
        MultiItemsInputComponent.prototype.addControl = function () {
            this.values.push(new forms.FormControl(''));
            this.onTouched();
        };
        MultiItemsInputComponent.prototype.removeValue = function (index) {
            this.values.removeAt(index);
            this.onTouched();
        };
        var MultiItemsInputComponent_1;
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], MultiItemsInputComponent.prototype, "name", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], MultiItemsInputComponent.prototype, "required", void 0);
        MultiItemsInputComponent = MultiItemsInputComponent_1 = __decorate([
            core.Component({
                selector: 'oav-multi-items-input',
                template: "<ng-container [formGroup]=\"formGroup\">\n  <div [formArrayName]=\"name\">\n    <div class=\"multi-item-entry\" *ngFor=\"let control of controls; let i = index\">\n      <input type=\"text\" [formControlName]=\"i.toString()\" (blur)=\"onTouched()\" />\n      <button type=\"button\" (click)=\"removeValue(i)\" [disabled]=\"disabled\">-</button>\n    </div>\n  </div>\n  <div class=\"oav-btn-container\">\n    <button type=\"button\" (click)=\"addControl()\" class=\"oav-add-btn\" [disabled]=\"disabled\">+</button>\n  </div>\n</ng-container>\n",
                providers: [
                    {
                        provide: forms.NG_VALUE_ACCESSOR,
                        useExisting: core.forwardRef(function () { return MultiItemsInputComponent_1; }),
                        multi: true
                    }
                ]
            }),
            __metadata("design:paramtypes", [])
        ], MultiItemsInputComponent);
        return MultiItemsInputComponent;
    }());

    var RequestsListComponent = /** @class */ (function () {
        function RequestsListComponent(openApiService) {
            this.openApiService = openApiService;
            this.openRequests = new Set();
            this.requests = [];
        }
        RequestsListComponent.prototype.ngOnInit = function () { };
        Object.defineProperty(RequestsListComponent.prototype, "openRequest", {
            set: function (req) {
                if (req) {
                    this.openRequests.clear();
                    this.openRequests.add(req);
                }
            },
            enumerable: true,
            configurable: true
        });
        RequestsListComponent.prototype.toggleRequest = function (req, state) {
            if (this.openRequests.has(req)) {
                this.openRequests.delete(req);
            }
            else {
                this.openRequests.add(req);
            }
        };
        RequestsListComponent.prototype.getShortUrl = function (req) {
            if (req.request.url.match(/^.+?\/\/.+?(\/[^?]*)/)) {
                return RegExp.$1;
            }
            return req.request.url;
        };
        RequestsListComponent.prototype.removeRequest = function (req) {
            this.requests.splice(this.requests.indexOf(req), 1);
            this.openRequests.delete(req);
            this.openApiService.removeRequest(req);
        };
        RequestsListComponent.ctorParameters = function () { return [
            { type: OpenapiViewerService }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], RequestsListComponent.prototype, "requests", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object),
            __metadata("design:paramtypes", [Object])
        ], RequestsListComponent.prototype, "openRequest", null);
        RequestsListComponent = __decorate([
            core.Component({
                selector: 'oav-requests-list',
                template: "<div *ngFor=\"let req of requests\" [className]=\"'oav-request method-' + req.request.method.toLowerCase()\" [id]=\"req.id\">\n  <oav-method-header\n    [method]=\"req.request.method\"\n    [path]=\"getShortUrl(req)\"\n    [open]=\"openRequests.has(req)\"\n    (openChange)=\"toggleRequest(req, $event)\"\n  >\n    {{ req.startTs | date: 'medium' }}\n    <strong class=\"ml-2\">\n      <span [ngClass]=\"'status status-' + req.status\" *ngIf=\"!req.running && req.status\">{{ req.status }} {{ req.statusText }}</span>\n      <span class=\"loading\" *ngIf=\"req.running\"></span>\n    </strong>\n  </oav-method-header>\n\n  <oav-request-view [request]=\"req\" [hidden]=\"!openRequests.has(req)\" (dismiss)=\"removeRequest(req)\"></oav-request-view>\n</div>\n"
            }),
            __metadata("design:paramtypes", [OpenapiViewerService])
        ], RequestsListComponent);
        return RequestsListComponent;
    }());

    var RequestViewComponent = /** @class */ (function () {
        function RequestViewComponent() {
            this.dismiss = new core.EventEmitter();
            this.displayLimitBytes = 1024 * 1024;
            this.displayMode = 'text';
            this.destroy = new rxjs.Subject();
        }
        RequestViewComponent.prototype.ngOnInit = function () {
            this.loadResponse();
        };
        RequestViewComponent.prototype.ngOnDestroy = function () {
            this.destroy.complete();
        };
        RequestViewComponent.prototype.loadResponse = function () {
            var _this = this;
            this.error = null;
            this.headers = '';
            this.body = '';
            this.request.httpEvents.pipe(operators.takeUntil(this.destroy)).subscribe(function (status) {
                if (status.type === http.HttpEventType.ResponseHeader || status.type === http.HttpEventType.Response) {
                    _this.setHeaders(status.headers);
                }
                if (status.type === http.HttpEventType.Response) {
                    _this.setBody(status);
                }
            }, function (err) {
                console.error('error response', err);
                if (err instanceof http.HttpErrorResponse) {
                    _this.setErrorBody(err);
                }
                _this.error = err.message;
            });
        };
        RequestViewComponent.prototype.setErrorBody = function (err) {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!(err.error instanceof Blob)) return [3 /*break*/, 2];
                            this.updateDisplayMode(err.error.type);
                            _a = this;
                            return [4 /*yield*/, getTextFromBlob(err.error)];
                        case 1:
                            _a.body = _b.sent();
                            _b.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        RequestViewComponent.prototype.updateDisplayMode = function (mimeType) {
            if (mimeType.startsWith('text')) {
                this.displayMode = 'text';
            }
            else if (mimeType.includes('json')) {
                this.displayMode = 'json';
            }
            else if (mimeType.includes('xml')) {
                this.displayMode = 'xml';
            }
            else {
                this.displayMode = 'download';
            }
        };
        RequestViewComponent.prototype.setBody = function (response) {
            return __awaiter(this, void 0, void 0, function () {
                var contentType, textTypes, body, parsed;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.blob = response.body;
                            contentType = response.headers.get('content-type');
                            textTypes = /^(application\/.{0,30}(json|xml)|text\/)/;
                            if (!(contentType.match(textTypes) && this.displayLimitBytes > this.blob.size)) return [3 /*break*/, 2];
                            this.displayMode = 'text';
                            return [4 /*yield*/, getTextFromBlob(response.body)];
                        case 1:
                            body = _a.sent();
                            if (contentType.startsWith('application/json') && body && body.length) {
                                this.displayMode = 'json';
                                try {
                                    parsed = JSON.parse(body);
                                    this.body = JSON.stringify(parsed, null, 2);
                                }
                                catch (e) {
                                    this.body = body;
                                    this.error = e;
                                }
                            }
                            else {
                                if (contentType.startsWith('application/xml')) {
                                    this.displayMode = 'xml';
                                }
                                this.body = body;
                            }
                            return [3 /*break*/, 3];
                        case 2:
                            this.displayMode = 'download';
                            _a.label = 3;
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        RequestViewComponent.prototype.setHeaders = function (headers) {
            var e_1, _a, e_2, _b;
            this.httpHeaders = headers;
            var headerLines = [];
            try {
                for (var _c = __values(headers.keys()), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var headerName = _d.value;
                    try {
                        for (var _e = (e_2 = void 0, __values(headers.getAll(headerName))), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var value = _f.value;
                            headerLines.push(headerName + ': ' + value);
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_1) throw e_1.error; }
            }
            this.headers = headerLines.join('\n');
        };
        RequestViewComponent.prototype.getDuration = function () {
            if (this.request.endTs) {
                return this.request.endTs.getTime() - this.request.startTs.getTime();
            }
            else if (this.request.running) {
                return new Date().getTime() - this.request.startTs.getTime();
            }
            else {
                return null;
            }
        };
        RequestViewComponent.prototype.doDismiss = function () {
            if (this.request.running) {
                this.request.cancel();
            }
            this.dismiss.next();
        };
        RequestViewComponent.prototype.download = function () {
            var contentType = this.httpHeaders.get('content-type');
            var contentDisposition = this.httpHeaders.get('content-disposition');
            var contentType2Ending = {
                'application/json': 'json',
                'application/xml': 'xml',
                'text/plain': 'txt',
                'image/png': 'png',
                'image/gif': 'gif',
                'image/jpeg': 'jpg'
            };
            var readableTs = new Date().toISOString().replace(/[-:]|\.\d{3}/g, '');
            var name = readableTs + '_' + this.request.operationsItem.operation.operationId;
            var mime = Object.keys(contentType2Ending).find(function (mimeType) { return contentType.startsWith(mimeType); });
            if (mime) {
                name += '.' + contentType2Ending[mime];
            }
            if (contentDisposition && contentDisposition.match(/filename="?(\w+)"?/)) {
                name = RegExp.$1;
            }
            var link = document.createElement('a');
            var url = URL.createObjectURL(this.blob);
            link.href = url;
            link.download = name;
            link.click();
            URL.revokeObjectURL(url);
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], RequestViewComponent.prototype, "request", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", Object)
        ], RequestViewComponent.prototype, "dismiss", void 0);
        RequestViewComponent = __decorate([
            core.Component({
                selector: 'oav-request-view',
                template: "<div class=\"oav-request-details\">\n  <div class=\"content\">\n    <div *ngIf=\"request.request.url\">\n      <div>\n        URL: <code>{{ request.request.url }}</code>\n      </div>\n    </div>\n    <div>\n      <div>\n        Status: <code>{{ request.status }} {{ request.statusText }}</code>\n      </div>\n    </div>\n    <div *ngIf=\"request.sentBytes\">\n      <div>\n        Bytes sent: <code>{{ request.sentBytes | number }}</code>\n      </div>\n    </div>\n\n    <h4>Response headers</h4>\n    <pre>{{ headers }}</pre>\n\n    <h4>\n      <span>Response body</span>\n      <span class=\"normal-text ml-2\">{{ request.receivedBytes | number }} bytes received after {{ getDuration() | number }} ms</span>\n    </h4>\n\n    <ng-container *ngIf=\"(displayMode === 'text' || displayMode === 'json' || displayMode === 'xml') && !request.running\">\n      <oav-code-input [ngModel]=\"body\" [mode]=\"displayMode\" [minLines]=\"5\" readonly></oav-code-input>\n    </ng-container>\n\n    <p class=\"oav-warning\" *ngIf=\"request.receivedBytes >= displayLimitBytes\">\n      Response is too large to be displayed. Please download it.\n    </p>\n\n    <pre *ngIf=\"error\" class=\"oav-error\">{{ error }}</pre>\n\n    <div class=\"d-flex justify-content-between\">\n      <button type=\"button\" class=\"download-btn\" (click)=\"download()\" *ngIf=\"!request.running\">Download</button>\n      <button type=\"button\" class=\"dismiss-btn\" (click)=\"doDismiss()\">{{ request.running ? 'Cancel' : 'Dismiss' }}</button>\n    </div>\n  </div>\n</div>\n"
            }),
            __metadata("design:paramtypes", [])
        ], RequestViewComponent);
        return RequestViewComponent;
    }());
    function getTextFromBlob(blob) {
        return new Promise(function (resolve, reject) {
            var reader = new FileReader();
            reader.onload = function (ev) {
                resolve(ev.target.result);
            };
            reader.onerror = function (err) {
                reject(err);
            };
            reader.readAsText(blob);
        });
    }

    var OpenableDirective = /** @class */ (function () {
        function OpenableDirective(element, renderer) {
            this.element = element;
            this.renderer = renderer;
            this.oavOpenable = true;
            this.open = false;
        }
        OpenableDirective.prototype.ngAfterViewInit = function () {
            if (this.oavOpenable !== false) {
                this.renderer.addClass(this.element.nativeElement, 'openable');
            }
        };
        OpenableDirective.prototype.onClick = function () {
            if (this.oavOpenable === false) {
                return;
            }
            this.open = !this.open;
            if (this.open) {
                this.renderer.addClass(this.element.nativeElement, 'open');
            }
            else {
                this.renderer.removeClass(this.element.nativeElement, 'open');
            }
        };
        OpenableDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], OpenableDirective.prototype, "oavOpenable", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], OpenableDirective.prototype, "open", void 0);
        __decorate([
            core.HostListener('click'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], OpenableDirective.prototype, "onClick", null);
        OpenableDirective = __decorate([
            core.Directive({
                selector: '[oavOpenable]',
                exportAs: 'openable'
            }),
            __metadata("design:paramtypes", [core.ElementRef, core.Renderer2])
        ], OpenableDirective);
        return OpenableDirective;
    }());

    var MethodHeaderComponent = /** @class */ (function () {
        function MethodHeaderComponent() {
            this.open = false;
            this.openChange = new core.EventEmitter();
        }
        MethodHeaderComponent.prototype.ngOnInit = function () { };
        MethodHeaderComponent.prototype.toggleOpen = function () {
            this.open = !this.open;
            this.openChange.next(this.open);
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], MethodHeaderComponent.prototype, "open", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", Object)
        ], MethodHeaderComponent.prototype, "openChange", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], MethodHeaderComponent.prototype, "fragment", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], MethodHeaderComponent.prototype, "method", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], MethodHeaderComponent.prototype, "path", void 0);
        MethodHeaderComponent = __decorate([
            core.Component({
                selector: 'oav-method-header',
                template: "<h3 (click)=\"toggleOpen()\" [className]=\"'oav-method-header oav-method-bg method-' + method.toLowerCase()\">\n  <a href=\"javascript:\" class=\"mainlink\" (click)=\"toggleOpen(); $event.stopPropagation()\">\n    <oav-method [method]=\"method\"></oav-method>\n    <span class=\"path ml-2\">{{ path }}</span>\n  </a>\n  <span class=\"summary\">\n    <ng-content></ng-content>\n  </span>\n  <button type=\"button\" class=\"toggle-button\" [class.open]=\"open\"></button>\n</h3>\n"
            }),
            __metadata("design:paramtypes", [])
        ], MethodHeaderComponent);
        return MethodHeaderComponent;
    }());

    var MethodComponent = /** @class */ (function () {
        function MethodComponent() {
        }
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], MethodComponent.prototype, "method", void 0);
        MethodComponent = __decorate([
            core.Component({
                selector: 'oav-method',
                template: "<span [ngClass]=\"'oav-method oav-method-' + method.toLowerCase()\">{{ method.toUpperCase() }}</span>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            })
        ], MethodComponent);
        return MethodComponent;
    }());

    var IndexNavComponent = /** @class */ (function () {
        function IndexNavComponent(router, oavSettings, cd) {
            this.router = router;
            this.oavSettings = oavSettings;
            this.cd = cd;
            this.openTags = new Set();
            if (!this.oavSettings) {
                this.oavSettings = defaultOavSettings;
            }
            this.showHoverLabel = !!this.oavSettings.indexHoverLabel;
            this.showAuthentication = this.oavSettings.enableAuthentication;
            this.showModelsOverview = this.oavSettings.enableModelsOverview;
        }
        IndexNavComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.checkOpenTags(this.router.routerState.snapshot.url);
            this.sub = this.router.events.pipe(operators.filter(function (ev) { return ev instanceof router.NavigationEnd; })).subscribe(function (event) {
                _this.checkOpenTags(event.url);
                _this.cd.markForCheck();
            });
            if (this.index && this.index.length === 1) {
                this.openTags.add(this.index[0].tag.name);
            }
        };
        IndexNavComponent.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        IndexNavComponent.prototype.checkOpenTags = function (url) {
            if (url.match(/\/(.+)\/(.+)/)) {
                var tag = RegExp.$1;
                this.openTags.add(tag);
            }
        };
        IndexNavComponent.ctorParameters = function () { return [
            { type: router.Router },
            { type: OavSettings, decorators: [{ type: core.Optional }] },
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], IndexNavComponent.prototype, "index", void 0);
        IndexNavComponent = __decorate([
            core.Component({
                selector: 'oav-index-nav',
                template: "<nav class=\"oav-index-nav\">\n  <ol class=\"oav-top-nav\">\n    <li>\n      <a routerLink=\"\" routerLinkActive=\"active\" [routerLinkActiveOptions]=\"{ exact: true }\">Overview</a>\n    </li>\n    <li *ngIf=\"showAuthentication\">\n      <a routerLink=\"/auth\" routerLinkActive=\"active\" [routerLinkActiveOptions]=\"{ exact: true }\">Authentication</a>\n    </li>\n    <li *ngIf=\"showModelsOverview\">\n      <a routerLink=\"/models\" routerLinkActive=\"active\" [routerLinkActiveOptions]=\"{ exact: true }\">Models overview</a>\n    </li>\n  </ol>\n\n  <ng-container *ngFor=\"let tag of index\">\n    <header oavOpenable #openable=\"openable\" [open]=\"openTags.has(tag.tag.name)\">\n      <a href=\"javascript:\">\n        <span>{{ tag.tag.name }}</span>\n        <button type=\"button\" class=\"toggle-button ml-auto\" [class.open]=\"openable.open\"></button>\n      </a>\n    </header>\n    <ol [hidden]=\"!openable.open\">\n      <oav-index-nav-endpoints [tag]=\"tag\"></oav-index-nav-endpoints>\n    </ol>\n  </ng-container>\n\n  <ol class=\"oav-bottom-nav\">\n    <li>\n      <span class=\"ml-3\">Powered by</span><br />\n      <a href=\"https://github.com/dhcode/openapi-ui\" target=\"_blank\">OpenAPI UI</a>\n    </li>\n  </ol>\n</nav>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(1, core.Optional()),
            __metadata("design:paramtypes", [router.Router, OavSettings, core.ChangeDetectorRef])
        ], IndexNavComponent);
        return IndexNavComponent;
    }());

    var OperationViewComponent = /** @class */ (function () {
        function OperationViewComponent(route, openApiService) {
            this.route = route;
            this.openApiService = openApiService;
            this.pathItem = null;
            this.operationItem = null;
            this.tag = null;
            this.error = null;
        }
        OperationViewComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = rxjs.combineLatest(this.route.params, this.openApiService.tagIndex).subscribe(function (_a) {
                var _b = __read(_a, 2), params = _b[0], index = _b[1];
                _this.loadData(index, params.tag, params.opId);
            });
        };
        OperationViewComponent.prototype.ngOnDestroy = function () {
            if (this.sub) {
                this.sub.unsubscribe();
            }
        };
        OperationViewComponent.prototype.loadData = function (index, tag, opId) {
            var e_1, _a;
            this.pathItem = null;
            this.operationItem = null;
            this.tag = tag;
            var tagIndex = index.find(function (idx) { return idx.tag.name === tag; });
            if (!tagIndex) {
                this.error = 'noTagFound';
                return;
            }
            try {
                for (var _b = __values(tagIndex.paths), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pi = _c.value;
                    var operationItem = pi.operations.find(function (op) { return op.operation.operationId === opId; });
                    if (operationItem) {
                        this.pathItem = pi;
                        this.operationItem = operationItem;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (!this.operationItem) {
                this.error = 'noOperationFound';
            }
        };
        OperationViewComponent.ctorParameters = function () { return [
            { type: router.ActivatedRoute },
            { type: OpenapiViewerService }
        ]; };
        OperationViewComponent = __decorate([
            core.Component({
                selector: 'oav-operation-view',
                template: "<div class=\"oav-content\">\n  <ng-container *ngIf=\"error === 'noOperationFound'\">\n    Operation was not found\n  </ng-container>\n  <ng-container *ngIf=\"error === 'noTagFound'\">\n    Tag was not found\n  </ng-container>\n  <ng-container *ngIf=\"operationItem\">\n    <oav-operation [tag]=\"tag\" [operationItem]=\"operationItem\" [pathItem]=\"pathItem\"></oav-operation>\n  </ng-container>\n</div>\n"
            }),
            __metadata("design:paramtypes", [router.ActivatedRoute, OpenapiViewerService])
        ], OperationViewComponent);
        return OperationViewComponent;
    }());

    var OverviewViewComponent = /** @class */ (function () {
        function OverviewViewComponent(openApiService, authService, cd) {
            this.openApiService = openApiService;
            this.authService = authService;
            this.cd = cd;
            this.index = [];
            this.spec = null;
        }
        OverviewViewComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = rxjs.combineLatest([this.openApiService.spec, this.openApiService.tagIndex]).subscribe(function (_a) {
                var _b = __read(_a, 2), spec = _b[0], index = _b[1];
                _this.spec = spec;
                _this.index = index;
                _this.cd.detectChanges();
            });
        };
        OverviewViewComponent.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        OverviewViewComponent.ctorParameters = function () { return [
            { type: OpenapiViewerService },
            { type: OpenapiAuthService },
            { type: core.ChangeDetectorRef }
        ]; };
        OverviewViewComponent = __decorate([
            core.Component({
                selector: 'oav-overview-view',
                template: "<div class=\"oav-content\">\n  <h1>{{ spec.info.title }}</h1>\n\n  <p *ngIf=\"spec.info.description\">\n    <markdown [data]=\"spec.info.description\"></markdown>\n  </p>\n\n  <div *ngIf=\"spec.info.termsOfService\">\n    <a [href]=\"spec.info.termsOfService\" target=\"_blank\">Terms of service</a>\n  </div>\n  <div *ngIf=\"spec.info.contact?.url\">\n    <a [href]=\"spec.info.contact.url\" target=\"_blank\">{{ spec.info.contact.name || 'Contact link' }}</a>\n  </div>\n  <div *ngIf=\"spec.info.contact?.email\">\n    <a [href]=\"'mailto:' + spec.info.contact.email\" target=\"_blank\">{{ spec.info.contact.name || 'Contact email' }}</a>\n  </div>\n  <div *ngIf=\"spec.info.license?.url\">\n    <a [href]=\"spec.info.license?.url\" target=\"_blank\">License: {{ spec.info.license.name }}</a>\n  </div>\n  <div *ngIf=\"spec.info.license && !spec.info.license.url\">License: {{ spec.info.license.name }}</div>\n\n  <ng-container *ngFor=\"let tag of index\">\n    <h2>{{ tag.tag.name }}</h2>\n    <p *ngIf=\"tag.tag.description\">{{ tag.tag.description }}</p>\n    <small *ngIf=\"tag.tag.externalDocs\" class=\"extra-link\">\n      {{ tag.tag.externalDocs.description }}:\n      <a [href]=\"tag.tag.externalDocs.url\" target=\"_blank\">{{ tag.tag.externalDocs.url }}</a>\n    </small>\n\n    <oav-overview-view-endpoints [tag]=\"tag\"></oav-overview-view-endpoints>\n  </ng-container>\n</div>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __metadata("design:paramtypes", [OpenapiViewerService, OpenapiAuthService, core.ChangeDetectorRef])
        ], OverviewViewComponent);
        return OverviewViewComponent;
    }());

    var AuthenticationViewComponent = /** @class */ (function () {
        function AuthenticationViewComponent(authService, route) {
            this.authService = authService;
            this.route = route;
            this.schemes = [];
            this.sub = null;
        }
        AuthenticationViewComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = this.authService.securitySchemes.subscribe(function (schemas) { return (_this.schemes = schemas); });
            this.route.fragment.subscribe(function (fragment) {
                if (fragment && fragment.length) {
                    var params = parseQueryString(fragment);
                    _this.authService.handleOAuthCallback(params);
                }
            });
            this.route.queryParams.subscribe(function (params) {
                if (params.state) {
                    _this.authService.handleOAuthCallback(params);
                }
            });
        };
        AuthenticationViewComponent.prototype.ngOnDestroy = function () {
            if (this.sub) {
                this.sub.unsubscribe();
            }
        };
        AuthenticationViewComponent.ctorParameters = function () { return [
            { type: OpenapiAuthService },
            { type: router.ActivatedRoute }
        ]; };
        AuthenticationViewComponent = __decorate([
            core.Component({
                selector: 'oav-authentication-view',
                template: "<div class=\"oav-content\">\n  <h1>Authentication schemes</h1>\n\n  <div *ngFor=\"let scheme of schemes\">\n    <h3>\n      {{ scheme.name }}\n      <span class=\"oav-auth-status ml-1\" [class.required]=\"!scheme.authenticated\" [class.ok]=\"scheme.authenticated\"></span>\n      <span class=\"ml-1 normal-text\">({{ scheme.securityScheme.type }})</span>\n    </h3>\n\n    <markdown *ngIf=\"scheme.securityScheme.description\" [data]=\"scheme.securityScheme.description\"></markdown>\n\n    <oav-auth-credentials [securityScheme]=\"scheme\"></oav-auth-credentials>\n  </div>\n\n  <p *ngIf=\"!schemes.length\">\n    No authentication schemes available.\n  </p>\n</div>\n"
            }),
            __metadata("design:paramtypes", [OpenapiAuthService, router.ActivatedRoute])
        ], AuthenticationViewComponent);
        return AuthenticationViewComponent;
    }());

    var categoryLabels = {
        schema: 'Schemas',
        response: 'Responses',
        parameter: 'Parameters',
        example: 'Examples',
        requestBody: 'RequestBodies',
        header: 'Headers',
        securityScheme: 'SecuritySchemes',
        link: 'Links',
        callback: 'Callbacks'
    };
    var ModelsViewComponent = /** @class */ (function () {
        function ModelsViewComponent(openApiService, oavSettings, cd) {
            this.openApiService = openApiService;
            this.oavSettings = oavSettings;
            this.cd = cd;
            this.categories = [];
            if (!this.oavSettings) {
                this.oavSettings = defaultOavSettings;
            }
        }
        Object.defineProperty(ModelsViewComponent.prototype, "showRaw", {
            get: function () {
                return this.oavSettings.showRawModelDefinition;
            },
            enumerable: true,
            configurable: true
        });
        ModelsViewComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = this.openApiService.spec.subscribe(function (spec) {
                _this.categories = identifyModels(spec);
                _this.cd.detectChanges();
            });
        };
        ModelsViewComponent.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        ModelsViewComponent.ctorParameters = function () { return [
            { type: OpenapiViewerService },
            { type: OavSettings, decorators: [{ type: core.Optional }] },
            { type: core.ChangeDetectorRef }
        ]; };
        ModelsViewComponent = __decorate([
            core.Component({
                selector: 'oav-models-view',
                template: "<div class=\"oav-content\">\n  <h1>Definitions</h1>\n\n  <ng-container *ngFor=\"let cat of categories\">\n    <h2>{{ cat.label }}</h2>\n\n    <div *ngFor=\"let def of cat.definitions\">\n      <h3>{{ def.name }}</h3>\n      <div class=\"ml-3\" *ngIf=\"def.schema\">\n        <oav-json-schema [schema]=\"def.schema\" [defaultModelName]=\"def.name\"></oav-json-schema>\n\n        <ng-container *ngIf=\"showRaw\">\n          <h4 oavOpenable #rawOpenable=\"openable\" class=\"toggle-button\">Raw {{ def.name }} model definition</h4>\n          <oav-code-input *ngIf=\"rawOpenable.open\" mode=\"json\" [ngModel]=\"def.schema | json\" readonly></oav-code-input>\n        </ng-container>\n      </div>\n    </div>\n  </ng-container>\n</div>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(1, core.Optional()),
            __metadata("design:paramtypes", [OpenapiViewerService, OavSettings, core.ChangeDetectorRef])
        ], ModelsViewComponent);
        return ModelsViewComponent;
    }());
    function getCategory(propName, categories) {
        var existing = categories.find(function (c) { return c.name === propName; });
        if (existing) {
            return existing;
        }
        var cat = {
            name: propName,
            label: categoryLabels[propName],
            definitions: []
        };
        categories.push(cat);
        return cat;
    }
    function addToCategory(defItem, categories) {
        var e_1, _a;
        var categoryPropsNames = Object.keys(categoryLabels);
        try {
            for (var categoryPropsNames_1 = __values(categoryPropsNames), categoryPropsNames_1_1 = categoryPropsNames_1.next(); !categoryPropsNames_1_1.done; categoryPropsNames_1_1 = categoryPropsNames_1.next()) {
                var propName = categoryPropsNames_1_1.value;
                if (defItem[propName]) {
                    var cat = getCategory(propName, categories);
                    cat.definitions.push(defItem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (categoryPropsNames_1_1 && !categoryPropsNames_1_1.done && (_a = categoryPropsNames_1.return)) _a.call(categoryPropsNames_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    function identifyModels(spec) {
        var categories = [];
        // OASv2
        if (spec.definitions) {
            Object.keys(spec.definitions)
                .map(function (name) { return getDefinitionsItem('schema', name, spec.definitions[name]); })
                .forEach(function (defItem) { return addToCategory(defItem, categories); });
        }
        if (spec.responses) {
            Object.keys(spec.responses)
                .map(function (name) { return getDefinitionsItem('response', name, spec.definitions[name]); })
                .forEach(function (defItem) { return addToCategory(defItem, categories); });
        }
        if (spec.parameters) {
            Object.keys(spec.parameters)
                .map(function (name) { return getDefinitionsItem('parameter', name, spec.definitions[name]); })
                .forEach(function (defItem) { return addToCategory(defItem, categories); });
        }
        // OASv3
        if (spec.components) {
            Object.keys(spec.components).forEach(function (categoryPlural) {
                var category = categoryPlural.substr(0, categoryPlural.length - 1);
                var cat = getCategory(category, categories);
                Object.keys(spec.components[categoryPlural])
                    .map(function (name) { return getDefinitionsItem(category, name, spec.components[categoryPlural][name]); })
                    .forEach(function (defItem) {
                    cat.definitions.push(defItem);
                });
            });
        }
        return categories;
    }
    function getDefinitionsItem(category, name, component) {
        var item = { name: name };
        item[category] = component;
        return item;
    }

    var routes = [
        {
            path: '',
            pathMatch: 'full',
            component: OverviewViewComponent
        },
        {
            path: 'auth',
            component: AuthenticationViewComponent
        },
        {
            path: 'models',
            component: ModelsViewComponent
        },
        {
            path: ':tag/:opId',
            component: OperationViewComponent
        }
    ];
    var OpenapiViewerRoutingModule = /** @class */ (function () {
        function OpenapiViewerRoutingModule() {
        }
        OpenapiViewerRoutingModule = __decorate([
            core.NgModule({
                imports: [router.RouterModule.forRoot(routes, { useHash: true })],
                exports: [router.RouterModule]
            })
        ], OpenapiViewerRoutingModule);
        return OpenapiViewerRoutingModule;
    }());

    var TabNavItemDirective = /** @class */ (function () {
        function TabNavItemDirective(templateRef) {
            this.templateRef = templateRef;
            this.id = randomHex(8);
            this.active = false;
        }
        Object.defineProperty(TabNavItemDirective.prototype, "oavTabNavItem", {
            set: function (label) {
                this.label = label;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TabNavItemDirective.prototype, "oavTabNavItemId", {
            set: function (id) {
                this.id = id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TabNavItemDirective.prototype, "oavTabNavItemDetails", {
            set: function (details) {
                this.details = details;
            },
            enumerable: true,
            configurable: true
        });
        TabNavItemDirective.ctorParameters = function () { return [
            { type: core.TemplateRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object),
            __metadata("design:paramtypes", [Object])
        ], TabNavItemDirective.prototype, "oavTabNavItem", null);
        __decorate([
            core.Input(),
            __metadata("design:type", String),
            __metadata("design:paramtypes", [String])
        ], TabNavItemDirective.prototype, "oavTabNavItemId", null);
        __decorate([
            core.Input(),
            __metadata("design:type", Object),
            __metadata("design:paramtypes", [Object])
        ], TabNavItemDirective.prototype, "oavTabNavItemDetails", null);
        TabNavItemDirective = __decorate([
            core.Directive({
                selector: '[oavTabNavItem]'
            }),
            __metadata("design:paramtypes", [core.TemplateRef])
        ], TabNavItemDirective);
        return TabNavItemDirective;
    }());

    var TabNavComponent = /** @class */ (function () {
        function TabNavComponent() {
            this.tabs = [];
            this.tabChange = new core.EventEmitter();
            this.destroy = new rxjs.Subject();
        }
        Object.defineProperty(TabNavComponent.prototype, "tabList", {
            set: function (tabs) {
                if (tabs) {
                    this.tabs = tabs.toArray();
                    this.checkForActiveTab();
                }
            },
            enumerable: true,
            configurable: true
        });
        TabNavComponent.prototype.ngOnChanges = function (changes) {
            if (changes.tab && !changes.tab.firstChange) {
                this.showTab(this.tab);
            }
        };
        TabNavComponent.prototype.ngOnDestroy = function () {
            this.destroy.complete();
        };
        TabNavComponent.prototype.checkForActiveTab = function () {
            if (!this.tabs.find(function (t) { return t.active; }) && this.tabs.length) {
                if (this.tab && this.getTabById(this.tab)) {
                    this.showTab(this.tab);
                }
                else {
                    this.showTab(this.tabs[0].id);
                }
            }
        };
        TabNavComponent.prototype.getTabById = function (id) {
            return this.tabs.find(function (tab) { return tab.id === id; });
        };
        TabNavComponent.prototype.showTab = function (id, notify) {
            var e_1, _a;
            if (notify === void 0) { notify = false; }
            try {
                for (var _b = __values(this.tabs), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var tab = _c.value;
                    if (tab.active && tab.id !== id) {
                        tab.active = false;
                    }
                    if (!tab.active && tab.id === id) {
                        tab.active = true;
                        this.tab = tab.id;
                        this.tabContent = tab.templateRef;
                        if (notify) {
                            this.tabChange.next(tab.id);
                        }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        __decorate([
            core.Output(),
            __metadata("design:type", Object)
        ], TabNavComponent.prototype, "tabChange", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], TabNavComponent.prototype, "tab", void 0);
        __decorate([
            core.ContentChildren(TabNavItemDirective, { descendants: true }),
            __metadata("design:type", core.QueryList),
            __metadata("design:paramtypes", [core.QueryList])
        ], TabNavComponent.prototype, "tabList", null);
        TabNavComponent = __decorate([
            core.Component({
                selector: 'oav-tab-nav',
                template: "<nav class=\"oav-tab-nav\">\n  <a href=\"javascript:\" *ngFor=\"let tab of tabs\" [class.active]=\"tab.active\" (click)=\"showTab(tab.id, true)\">\n    <oav-template-outlet [tpl]=\"tab.label\" [ctx]=\"tab\"></oav-template-outlet>\n  </a>\n</nav>\n<div class=\"oav-tab-content\">\n  <ng-container *ngTemplateOutlet=\"tabContent\"></ng-container>\n</div>\n"
            }),
            __metadata("design:paramtypes", [])
        ], TabNavComponent);
        return TabNavComponent;
    }());

    var TemplateOutletComponent = /** @class */ (function () {
        function TemplateOutletComponent() {
        }
        TemplateOutletComponent.prototype.isTemplate = function () {
            return this.tpl instanceof core.TemplateRef;
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], TemplateOutletComponent.prototype, "tpl", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], TemplateOutletComponent.prototype, "ctx", void 0);
        TemplateOutletComponent = __decorate([
            core.Component({
                selector: 'oav-template-outlet',
                template: "<ng-container *ngIf=\"isTemplate(); else noTpl\">\n  <ng-container *ngTemplateOutlet=\"tpl; context: ctx\"></ng-container>\n</ng-container>\n<ng-template #noTpl>{{ tpl }}</ng-template>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            })
        ], TemplateOutletComponent);
        return TemplateOutletComponent;
    }());

    var RequestBodyInputComponent = /** @class */ (function () {
        function RequestBodyInputComponent() {
            this.formGroup = new forms.FormGroup({
                contentType: new forms.FormControl()
            });
            this.contentParameters = {};
            this.contentTypes = [];
            this.currentParameters = [];
        }
        RequestBodyInputComponent.prototype.ngOnInit = function () {
            this.addToFormGroup.addControl('requestBody', this.formGroup);
        };
        RequestBodyInputComponent.prototype.ngOnDestroy = function () {
            this.addToFormGroup.removeControl('requestBody');
        };
        RequestBodyInputComponent.prototype.ngOnChanges = function (changes) {
            this.identifyParameters();
        };
        RequestBodyInputComponent.prototype.identifyParameters = function () {
            var e_1, _a;
            this.contentParameters = {};
            this.contentTypes = [];
            if (!this.requestBody || !this.requestBody.content) {
                return;
            }
            this.contentTypes = Object.keys(this.requestBody.content);
            if (this.contentTypes.length) {
                try {
                    for (var _b = __values(this.contentTypes), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var type = _c.value;
                        this.contentParameters[type] = this.contentToParameter(type, this.requestBody.content[type]);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                this.currentContentType = this.contentTypes[0];
                this.currentParameters = this.contentParameters[this.currentContentType];
                this.formGroup.patchValue({ contentType: this.currentContentType });
            }
        };
        RequestBodyInputComponent.prototype.contentToParameter = function (mediaType, def) {
            if ((mediaType === 'application/x-www-form-urlencoded' || mediaType.startsWith('multipart')) && def.schema) {
                var schema_1 = def.schema;
                if ((schema_1.type === 'object' || !schema_1.type) && schema_1.properties) {
                    return Object.keys(schema_1.properties).map(function (key) {
                        var propScheme = schema_1.properties[key];
                        return {
                            name: key,
                            customIn: 'form-data',
                            required: schema_1.required && schema_1.required.includes(key),
                            description: propScheme.description,
                            schema: propScheme
                        };
                    });
                }
            }
            var param = {
                name: 'requestBody',
                customIn: 'body',
                required: this.requestBody.required,
                description: this.requestBody.description,
                schema: def.schema,
                example: def.example,
                examples: def.examples
            };
            return [param];
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], RequestBodyInputComponent.prototype, "requestBody", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", forms.FormGroup)
        ], RequestBodyInputComponent.prototype, "addToFormGroup", void 0);
        RequestBodyInputComponent = __decorate([
            core.Component({
                selector: 'oav-request-body-input',
                template: "<ng-container *ngFor=\"let param of currentParameters\">\n  <oav-parameter [parameter]=\"param\" [formGroup]=\"formGroup\"></oav-parameter>\n</ng-container>\n"
            }),
            __metadata("design:paramtypes", [])
        ], RequestBodyInputComponent);
        return RequestBodyInputComponent;
    }());

    var AuthCredentialsComponent = /** @class */ (function () {
        function AuthCredentialsComponent(authService) {
            this.authService = authService;
            this.displayMode = 'unknown';
            this.username = new forms.FormControl('');
            this.password = new forms.FormControl('');
            this.apiKey = new forms.FormControl('');
            this.clientId = new forms.FormControl('');
            this.clientSecret = new forms.FormControl('');
            this.scopes = new forms.FormArray([]);
            this.flow = new forms.FormControl('');
            this.remember = new forms.FormControl(false);
            this.scopesInfo = [];
            this.loading = false;
            this.error = null;
            /**
             * The available flows
             */
            this.flows = [];
        }
        AuthCredentialsComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = this.flow.valueChanges.subscribe(function (flow) {
                _this.readOAuthCredentials(flow);
            });
        };
        AuthCredentialsComponent.prototype.ngOnChanges = function (changes) {
            if (changes.securityScheme && this.securityScheme) {
                this.checkScheme();
            }
        };
        AuthCredentialsComponent.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        AuthCredentialsComponent.prototype.checkScheme = function () {
            var type = this.securityScheme.securityScheme.type;
            if (type === 'apiKey') {
                this.displayMode = 'apiKey';
                this.readApiKey();
            }
            else if (type === 'http' || type === 'basic') {
                this.displayMode = 'usernamePassword';
                this.readHttpCredentials();
            }
            else if (type === 'oauth2' || type === 'openIdConnect') {
                this.displayMode = 'oauth';
                this.readOAuthCredentials();
            }
            else {
                this.displayMode = 'unknown';
            }
            if (this.securityScheme.remember) {
                this.remember.patchValue(true);
            }
        };
        AuthCredentialsComponent.prototype.readApiKey = function () {
            this.formGroup = new forms.FormGroup({ apiKey: this.apiKey, remember: this.remember });
            if (typeof this.securityScheme.credentials === 'string') {
                this.apiKey.patchValue(this.securityScheme.credentials);
            }
            else {
                this.apiKey.patchValue('');
            }
        };
        AuthCredentialsComponent.prototype.readHttpCredentials = function () {
            this.formGroup = new forms.FormGroup({ username: this.username, password: this.password, remember: this.remember });
            var credentials = this.securityScheme.credentials;
            if (typeof credentials === 'object' && credentials) {
                if (typeof credentials.username === 'string') {
                    this.username.patchValue(credentials.username);
                }
                else {
                    this.username.patchValue('');
                }
                if (typeof credentials.password === 'string') {
                    this.password.patchValue(credentials.password);
                }
                else {
                    this.password.patchValue('');
                }
            }
            else {
                this.username.patchValue('');
                this.password.patchValue('');
            }
        };
        AuthCredentialsComponent.prototype.readOAuthCredentials = function (flow) {
            var e_1, _a, e_2, _b;
            var credentials = this.securityScheme.credentials;
            if (!flow && credentials && credentials.flow) {
                flow = credentials.flow;
            }
            this.flows = identifyFlows(this.securityScheme.securityScheme);
            var currentFlow = flow ? this.flows.find(function (f) { return f.flow === flow; }) : this.flows[0];
            if (!currentFlow) {
                return;
            }
            if (credentials) {
                this.token = credentials.token;
            }
            this.currentFlow = currentFlow;
            this.scopesInfo = currentFlow.scopes;
            this.formGroup = new forms.FormGroup({
                clientId: this.clientId,
                clientSecret: this.clientSecret,
                username: this.username,
                password: this.password,
                scopes: this.scopes,
                remember: this.remember
            });
            this.scopes.clear();
            this.remember.patchValue(true);
            this.flow.patchValue(currentFlow.flow);
            if (typeof credentials === 'object' && credentials) {
                this.clientId.patchValue(credentials.clientId);
                this.clientSecret.patchValue(credentials.clientSecret);
                this.username.patchValue(credentials.username || '');
                this.password.patchValue(credentials.password || '');
                try {
                    for (var _c = __values(this.scopesInfo), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var scope = _d.value;
                        this.scopes.push(new forms.FormControl(credentials.scopes.includes(scope.scope)));
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
            else {
                this.clientId.patchValue('');
                try {
                    for (var _e = __values(this.scopesInfo), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var scope = _f.value;
                        this.scopes.push(new forms.FormControl(true));
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        };
        AuthCredentialsComponent.prototype.save = function () {
            var _this = this;
            if (this.displayMode === 'apiKey') {
                this.authService.updateCredentials(this.securityScheme.name, this.apiKey.value, this.apiKey.value.length > 0, this.remember.value);
            }
            if (this.displayMode === 'usernamePassword') {
                this.authService.updateCredentials(this.securityScheme.name, {
                    username: this.username.value,
                    password: this.password.value
                }, this.username.value.length > 0, this.remember.value);
            }
            if (this.displayMode === 'oauth') {
                var scopes = this.scopesInfo.map(function (s, i) { return (_this.scopes.value[i] ? s.scope : null); }).filter(function (s) { return !!s; });
                var credentials = {
                    clientId: this.clientId.value,
                    clientSecret: this.clientSecret.value,
                    username: this.username.value,
                    password: this.password.value,
                    flow: this.flow.value,
                    scopes: scopes,
                    token: null,
                    nonce: randomHex(16),
                    redirectUri: getCurrentUrl()
                };
                this.loading = true;
                this.error = null;
                this.authService.runOAuthAuthorization(this.securityScheme.name, credentials).subscribe(function () {
                    _this.loading = false;
                }, function (err) {
                    _this.loading = false;
                    _this.error = err;
                });
            }
            this.formGroup.markAsPristine();
        };
        AuthCredentialsComponent.prototype.removeToken = function () {
            this.authService.removeToken(this.securityScheme.name);
        };
        AuthCredentialsComponent.ctorParameters = function () { return [
            { type: OpenapiAuthService }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], AuthCredentialsComponent.prototype, "securityScheme", void 0);
        AuthCredentialsComponent = __decorate([
            core.Component({
                selector: 'oav-auth-credentials',
                template: "<form action=\"javascript:\" (submit)=\"save()\" *ngIf=\"formGroup\" [formGroup]=\"formGroup\">\n  <ng-container *ngIf=\"displayMode === 'apiKey'\">\n    <div class=\"oav-parameter\">\n      <div class=\"name\">\n        <div><strong>API Key</strong>:</div>\n        <div class=\"param-in\">\n          {{ securityScheme.securityScheme.in }}\n          <span class=\"format\" *ngIf=\"securityScheme.securityScheme.scheme\">({{ securityScheme.securityScheme.scheme }})</span>\n        </div>\n      </div>\n      <div class=\"input\">\n        <input [formControl]=\"apiKey\" name=\"apiKey\" />\n      </div>\n    </div>\n    <button class=\"send-btn\" [disabled]=\"formGroup.pristine\">Save</button>\n    <label class=\"ml-2\">\n      <input type=\"checkbox\" [formControl]=\"remember\" />\n      Remember in browser session\n    </label>\n  </ng-container>\n  <ng-container *ngIf=\"displayMode === 'usernamePassword'\">\n    <div class=\"oav-parameter\">\n      <div class=\"name\">\n        <div><strong>Username</strong>:</div>\n        <div class=\"param-in\">\n          {{ securityScheme.securityScheme.in }}\n          <span class=\"format\" *ngIf=\"securityScheme.securityScheme.scheme\">({{ securityScheme.securityScheme.scheme }})</span>\n        </div>\n      </div>\n      <div class=\"input\">\n        <input [formControl]=\"username\" name=\"username\" />\n      </div>\n    </div>\n    <div class=\"oav-parameter\">\n      <div class=\"name\">\n        <div><strong>Password</strong>:</div>\n        <div class=\"param-in\">\n          {{ securityScheme.securityScheme.in }}\n          <span class=\"format\" *ngIf=\"securityScheme.securityScheme.scheme\">({{ securityScheme.securityScheme.scheme }})</span>\n        </div>\n      </div>\n      <div class=\"input\">\n        <input [formControl]=\"password\" type=\"password\" name=\"password\" />\n      </div>\n    </div>\n    <button class=\"send-btn\" [disabled]=\"formGroup.pristine\">Save</button>\n    <label class=\"ml-2\">\n      <input type=\"checkbox\" [formControl]=\"remember\" />\n      Remember in browser session\n    </label>\n  </ng-container>\n  <ng-container *ngIf=\"displayMode === 'oauth'\">\n    <div class=\"oav-parameter\" *ngIf=\"token\">\n      <div class=\"name\">\n        <div><strong>Current token</strong>:</div>\n      </div>\n      <div class=\"input\">\n        <div>\n          Access token: <code>{{ token.access_token }}</code>\n        </div>\n        <div>\n          Token type: <code>{{ token.token_type }}</code>\n        </div>\n        <div *ngIf=\"token.expires_at\">Expires {{ token.expires_at | date: 'long' }}</div>\n        <button type=\"button\" class=\"dismiss-btn\" (click)=\"removeToken()\">Remove token</button>\n      </div>\n    </div>\n    <div class=\"oav-parameter\">\n      <div class=\"name\">\n        <div><strong>Flow</strong>:</div>\n      </div>\n      <div class=\"input\">\n        <select [formControl]=\"flow\" name=\"flow\">\n          <option *ngFor=\"let f of flows\" [value]=\"f.flow\">{{ f.flow }}</option>\n        </select>\n      </div>\n    </div>\n    <div class=\"oav-parameter\">\n      <div class=\"name\">\n        <div><strong>Client ID</strong>:</div>\n      </div>\n      <div class=\"input\">\n        <input [formControl]=\"clientId\" name=\"clientId\" />\n      </div>\n    </div>\n    <div class=\"oav-parameter\" *ngIf=\"flow.value === 'authorizationCode' || flow.value === 'clientCredentials'\">\n      <div class=\"name\">\n        <div><strong>Client Secret</strong>:</div>\n      </div>\n      <div class=\"input\">\n        <input [formControl]=\"clientSecret\" type=\"password\" name=\"clientSecret\" />\n      </div>\n    </div>\n    <div class=\"oav-parameter\" *ngIf=\"flow.value === 'password'\">\n      <div class=\"name\">\n        <div><strong>Username</strong>:</div>\n      </div>\n      <div class=\"input\">\n        <input [formControl]=\"username\" name=\"username\" />\n      </div>\n    </div>\n    <div class=\"oav-parameter\" *ngIf=\"flow.value === 'password'\">\n      <div class=\"name\">\n        <div><strong>Password</strong>:</div>\n      </div>\n      <div class=\"input\">\n        <input [formControl]=\"password\" type=\"password\" name=\"password\" />\n      </div>\n    </div>\n    <div class=\"oav-parameter\">\n      <div class=\"name\">\n        <div><strong>Scopes</strong>:</div>\n        <div class=\"param-in\">\n          {{ securityScheme.securityScheme.in }}\n          <span class=\"format\" *ngIf=\"securityScheme.securityScheme.scheme\">({{ securityScheme.securityScheme.scheme }})</span>\n        </div>\n      </div>\n      <div class=\"input\" [formArrayName]=\"'scopes'\">\n        <div *ngFor=\"let scope of scopesInfo; let i = index\">\n          <label>\n            <input type=\"checkbox\" [formControlName]=\"i\" [value]=\"scope.scope\" />\n            {{ scope.description }}\n          </label>\n        </div>\n      </div>\n    </div>\n    <button class=\"send-btn\" [disabled]=\"formGroup.invalid || loading\" [class.loading]=\"loading\">Authenticate</button>\n    <label class=\"ml-2\">\n      <input type=\"checkbox\" [formControl]=\"remember\" required />\n      Remember in browser session\n    </label>\n    <div class=\"oav-error\" *ngIf=\"error\">{{ error }}</div>\n  </ng-container>\n</form>\n<ng-container *ngIf=\"displayMode === 'unknown'\">\n  <p>Unsupported authentication scheme '{{ securityScheme?.securityScheme?.type }}'</p>\n</ng-container>\n"
            }),
            __metadata("design:paramtypes", [OpenapiAuthService])
        ], AuthCredentialsComponent);
        return AuthCredentialsComponent;
    }());
    function getCurrentUrl() {
        var url = window.location.href;
        var idx = url.indexOf('?');
        if (idx !== -1) {
            return url.slice(0, idx);
        }
        return url;
    }

    var AuthStatusComponent = /** @class */ (function () {
        function AuthStatusComponent(oavSettings, authService, cd) {
            this.oavSettings = oavSettings;
            this.authService = authService;
            this.cd = cd;
            this.schemeNames = [];
            if (!this.oavSettings) {
                this.oavSettings = defaultOavSettings;
            }
            this.showAuthentication = this.oavSettings.enableAuthentication;
        }
        AuthStatusComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.sub = this.authService.updatedCredentials.subscribe(function (schemeName) {
                if (_this.schemeNames.includes(schemeName)) {
                    _this.cd.detectChanges();
                }
            });
        };
        AuthStatusComponent.prototype.ngOnDestroy = function () {
            this.sub.unsubscribe();
        };
        AuthStatusComponent.prototype.ngOnChanges = function (changes) {
            var e_1, _a, e_2, _b;
            if (changes.operation) {
                this.authStatus = this.authService.getAuthStatus(this.operation.security);
                this.requiredSchemes = this.authService.getRequiredSchemes(this.operation.security);
                this.schemeNames = [];
                try {
                    for (var _c = __values(this.requiredSchemes), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var reqs = _d.value;
                        try {
                            for (var reqs_1 = (e_2 = void 0, __values(reqs)), reqs_1_1 = reqs_1.next(); !reqs_1_1.done; reqs_1_1 = reqs_1.next()) {
                                var scheme = reqs_1_1.value;
                                this.schemeNames.push(scheme.name);
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (reqs_1_1 && !reqs_1_1.done && (_b = reqs_1.return)) _b.call(reqs_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
        };
        AuthStatusComponent.ctorParameters = function () { return [
            { type: OavSettings, decorators: [{ type: core.Optional }] },
            { type: OpenapiAuthService },
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], AuthStatusComponent.prototype, "operation", void 0);
        __decorate([
            core.ViewChild(portal.CdkPortal, { static: true }),
            __metadata("design:type", portal.CdkPortal)
        ], AuthStatusComponent.prototype, "portal", void 0);
        __decorate([
            core.ViewChild('statusIcon'),
            __metadata("design:type", core.ElementRef)
        ], AuthStatusComponent.prototype, "statusIcon", void 0);
        AuthStatusComponent = __decorate([
            core.Component({
                selector: 'oav-auth-status',
                template: "<span\n  #statusIcon\n  class=\"oav-auth-status ml-1\"\n  *ngIf=\"showAuthentication\"\n  [class.required]=\"authStatus === 'required'\"\n  [class.ok]=\"authStatus === 'ok'\"\n  [oavTooltip]=\"authStatus !== 'none' ? portal : null\"\n></span>\n\n<oav-tooltip *cdkPortal>\n  <ng-container *ngFor=\"let reqs of requiredSchemes\">\n    <div *ngFor=\"let status of reqs\">\n      <h4 class=\"m-0\">\n        {{ status.name }}\n        <span class=\"oav-auth-status ml-1\" [class.required]=\"!status.authenticated\" [class.ok]=\"status.authenticated\"></span>\n        <span class=\"ml-1 normal-text\" *ngIf=\"status.authenticated\">authenticated</span>\n        <span class=\"ml-1 normal-text\" *ngIf=\"!status.authenticated\">not provided</span>\n      </h4>\n      <ng-container *ngIf=\"status.scopes?.length\"> Required scopes: {{ status.scopes.join(', ') }} </ng-container>\n    </div>\n  </ng-container>\n</oav-tooltip>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(0, core.Optional()),
            __metadata("design:paramtypes", [OavSettings, OpenapiAuthService, core.ChangeDetectorRef])
        ], AuthStatusComponent);
        return AuthStatusComponent;
    }());

    var TooltipComponent = /** @class */ (function () {
        function TooltipComponent() {
        }
        TooltipComponent.prototype.ngOnInit = function () { };
        TooltipComponent = __decorate([
            core.Component({
                selector: 'oav-tooltip',
                template: "<ng-content></ng-content>\n"
            }),
            __metadata("design:paramtypes", [])
        ], TooltipComponent);
        return TooltipComponent;
    }());

    var TooltipDirective = /** @class */ (function () {
        function TooltipDirective(overlay, elementRef, viewContainer) {
            this.overlay = overlay;
            this.elementRef = elementRef;
            this.viewContainer = viewContainer;
            this.fixed = false;
        }
        TooltipDirective.prototype.onClick = function (e) {
            e.stopPropagation();
            this.fixed = true;
            this.open();
        };
        TooltipDirective.prototype.onMouseEnter = function (e) {
            this.open();
        };
        TooltipDirective.prototype.onMouseLeave = function (e) {
            if (!this.fixed) {
                this.close();
            }
        };
        TooltipDirective.prototype.onWindowClick = function () {
            this.close();
        };
        TooltipDirective.prototype.ngOnDestroy = function () {
            this.close();
        };
        TooltipDirective.prototype.open = function () {
            if (this.overlayRef || !this.oavTooltip) {
                return;
            }
            this.overlayRef = this.overlay.create({
                positionStrategy: this.overlay
                    .position()
                    .flexibleConnectedTo(this.elementRef)
                    .withPositions([
                    {
                        overlayX: 'start',
                        overlayY: 'top',
                        originX: 'start',
                        originY: 'bottom'
                    }
                ])
            });
            this.overlayRef.attach(this.oavTooltip);
        };
        TooltipDirective.prototype.close = function () {
            this.fixed = false;
            if (this.overlayRef) {
                this.overlayRef.dispose();
                this.overlayRef = null;
            }
        };
        TooltipDirective.ctorParameters = function () { return [
            { type: overlay.Overlay },
            { type: core.ElementRef },
            { type: core.ViewContainerRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", portal.CdkPortal)
        ], TooltipDirective.prototype, "oavTooltip", void 0);
        __decorate([
            core.HostListener('click', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [MouseEvent]),
            __metadata("design:returntype", void 0)
        ], TooltipDirective.prototype, "onClick", null);
        __decorate([
            core.HostListener('mouseenter', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [MouseEvent]),
            __metadata("design:returntype", void 0)
        ], TooltipDirective.prototype, "onMouseEnter", null);
        __decorate([
            core.HostListener('mouseleave', ['$event']),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [MouseEvent]),
            __metadata("design:returntype", void 0)
        ], TooltipDirective.prototype, "onMouseLeave", null);
        __decorate([
            core.HostListener('window:click'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], TooltipDirective.prototype, "onWindowClick", null);
        TooltipDirective = __decorate([
            core.Directive({
                selector: '[oavTooltip]'
            }),
            __metadata("design:paramtypes", [overlay.Overlay, core.ElementRef, core.ViewContainerRef])
        ], TooltipDirective);
        return TooltipDirective;
    }());

    var ajv = new Ajv({
        unknownFormats: 'ignore'
    });
    ajv.addFormat('int32', {
        type: 'number',
        validate: function (data) { return !isNaN(data) && data % 1 === 0 && data <= Math.pow(2, 31) && data >= Math.pow(2, 31) * -1; }
    });
    ajv.addFormat('int64', {
        type: 'number',
        validate: function (data) { return !isNaN(data) && data % 1 === 0; }
    });
    ajv.addFormat('float', {
        type: 'number',
        validate: function (data) { return !isNaN(data); }
    });
    ajv.addFormat('double', {
        type: 'number',
        validate: function (data) { return !isNaN(data); }
    });
    ajv.addFormat('byte', {
        type: 'string',
        validate: function (data) { return /^[0-9A-Za-z+/]*=?=?$/.test(data); }
    });
    function getValidationFunction(schema) {
        return ajv.compile(schema);
    }

    var CodeInputComponent = /** @class */ (function () {
        function CodeInputComponent(cd) {
            this.cd = cd;
            this.config = {};
            this.disabled = false;
            this.value = '';
            this.mode = 'text';
            this.minLines = 1;
            this.maxLines = 20;
            this.schema = null;
            this.errors = [];
            this.writing = false;
            this.validate = null;
            this.changes = new rxjs.Subject();
            this.onChange = function (v) { };
            this.onTouched = function () { };
        }
        CodeInputComponent_1 = CodeInputComponent;
        CodeInputComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.changes.pipe(operators.debounceTime(100)).subscribe(function () { return _this.checkValue(); });
        };
        CodeInputComponent.prototype.ngOnDestroy = function () {
            this.changes.complete();
        };
        CodeInputComponent.prototype.ngOnChanges = function (changes) {
            if (this.schema) {
                try {
                    this.validate = getValidationFunction(this.schema);
                }
                catch (e) {
                    console.error('Failed to get validation function for schema', this.schema, e);
                    this.validate = null;
                    this.errors = [e.message];
                }
            }
            else {
                this.validate = null;
                this.errors = [];
            }
            this.updateConfig();
        };
        CodeInputComponent.prototype.updateConfig = function () {
            this.config = {
                minLines: this.minLines,
                maxLines: this.maxLines,
                wrap: true,
                tabSize: 2
            };
            if (this.readonly || this.readonly === '') {
                this.config.readOnly = true;
            }
        };
        CodeInputComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        CodeInputComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        CodeInputComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        CodeInputComponent.prototype.writeValue = function (obj) {
            this.value = obj;
            this.writing = true;
            try {
                this.cd.detectChanges();
            }
            catch (e) {
                console.error('Update Ace error', this.value, e);
            }
            this.writing = false;
            this.changes.next();
        };
        CodeInputComponent.prototype.updateValue = function (value) {
            if (!this.writing) {
                this.value = value;
                this.changes.next();
                this.onChange(value);
            }
        };
        CodeInputComponent.prototype.checkValue = function () {
            if (this.validate && this.mode === 'json') {
                this.errors = [];
                if (!this.value) {
                    return;
                }
                try {
                    var text = JSON.parse(this.value);
                    if (!this.validate(text)) {
                        this.errors = this.validate.errors.map(function (e) { return e.dataPath + ": " + e.keyword + " " + e.message; });
                    }
                }
                catch (e) {
                    this.errors = [e.message];
                }
            }
        };
        var CodeInputComponent_1;
        CodeInputComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], CodeInputComponent.prototype, "readonly", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], CodeInputComponent.prototype, "mode", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], CodeInputComponent.prototype, "minLines", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], CodeInputComponent.prototype, "maxLines", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], CodeInputComponent.prototype, "schema", void 0);
        CodeInputComponent = CodeInputComponent_1 = __decorate([
            core.Component({
                selector: 'oav-code-input',
                template: "<div>\n  <ace [config]=\"config\" [mode]=\"mode\" [value]=\"value\" (valueChange)=\"updateValue($event)\"></ace>\n</div>\n<div *ngFor=\"let err of errors\" class=\"oav-error\">{{ err }}</div>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                providers: [
                    {
                        provide: forms.NG_VALUE_ACCESSOR,
                        useExisting: core.forwardRef(function () { return CodeInputComponent_1; }),
                        multi: true
                    }
                ]
            }),
            __metadata("design:paramtypes", [core.ChangeDetectorRef])
        ], CodeInputComponent);
        return CodeInputComponent;
    }());

    function getLabel(op, pathItem, fields) {
        var e_1, _a;
        try {
            for (var fields_1 = __values(fields), fields_1_1 = fields_1.next(); !fields_1_1.done; fields_1_1 = fields_1.next()) {
                var field = fields_1_1.value;
                if (field === 'path') {
                    return pathItem.path;
                }
                if (op.operation[field]) {
                    return op.operation[field];
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (fields_1_1 && !fields_1_1.done && (_a = fields_1.return)) _a.call(fields_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return '';
    }

    var IndexNavEndpointsComponent = /** @class */ (function () {
        function IndexNavEndpointsComponent(oavSettings) {
            this.oavSettings = oavSettings;
            if (!this.oavSettings) {
                this.oavSettings = defaultOavSettings;
            }
            this.showHoverLabel = !!this.oavSettings.indexHoverLabel;
        }
        IndexNavEndpointsComponent.prototype.getPrimaryLabel = function (op, pathItem) {
            return getLabel(op, pathItem, this.oavSettings.indexPrimaryLabel);
        };
        IndexNavEndpointsComponent.prototype.getHoverLabel = function (op, pathItem) {
            return getLabel(op, pathItem, this.oavSettings.indexHoverLabel);
        };
        IndexNavEndpointsComponent.ctorParameters = function () { return [
            { type: OavSettings, decorators: [{ type: core.Optional }] }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], IndexNavEndpointsComponent.prototype, "tag", void 0);
        IndexNavEndpointsComponent = __decorate([
            core.Component({
                selector: 'oav-index-nav-endpoints',
                template: "<ng-container *ngFor=\"let pathItem of tag.paths\">\n  <ng-container *ngFor=\"let op of pathItem.operations\">\n    <li>\n      <a [routerLink]=\"tag.tag.name + '/' + op.operation.operationId\" routerLinkActive=\"active\">\n        <span class=\"label\">\n          <oav-method class=\"font-size-smaller\" [method]=\"op.method\"></oav-method>\n          <span [class.deprecated]=\"op.operation.deprecated\">{{ getPrimaryLabel(op, pathItem) }}</span>\n        </span>\n        <span class=\"info-overlay\" *ngIf=\"showHoverLabel\">\n          <oav-method class=\"font-size-smaller\" [method]=\"op.method\"></oav-method>\n          <span [class.deprecated]=\"op.operation.deprecated\">{{ getHoverLabel(op, pathItem) }}</span>\n        </span>\n      </a>\n    </li>\n  </ng-container>\n</ng-container>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(0, core.Optional()),
            __metadata("design:paramtypes", [OavSettings])
        ], IndexNavEndpointsComponent);
        return IndexNavEndpointsComponent;
    }());

    var OverviewViewEndpointsComponent = /** @class */ (function () {
        function OverviewViewEndpointsComponent(oavSettings) {
            this.oavSettings = oavSettings;
            if (!this.oavSettings) {
                this.oavSettings = defaultOavSettings;
            }
        }
        OverviewViewEndpointsComponent.prototype.getLabel = function (op, pathItem) {
            return getLabel(op, pathItem, this.oavSettings.overviewPrimaryLabel);
        };
        OverviewViewEndpointsComponent.ctorParameters = function () { return [
            { type: OavSettings, decorators: [{ type: core.Optional }] }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], OverviewViewEndpointsComponent.prototype, "tag", void 0);
        OverviewViewEndpointsComponent = __decorate([
            core.Component({
                selector: 'oav-overview-view-endpoints',
                template: "<ng-container *ngFor=\"let pathItem of tag.paths\">\n  <ng-container *ngFor=\"let op of pathItem.operations\">\n    <h3>\n      <oav-method [method]=\"op.method\"></oav-method>\n      <oav-auth-status [operation]=\"op.operation\"></oav-auth-status>\n      <a [routerLink]=\"tag.tag.name + '/' + op.operation.operationId\" routerLinkActive=\"active\" class=\"oav-header-link ml-1\">\n        <span class=\"oav-path\" [class.deprecated]=\"op.operation.deprecated\">{{ pathItem.path }}</span>\n        <span class=\"oav-summary font-size-smaller ml-2\">{{ getLabel(op, pathItem) }}</span>\n      </a>\n    </h3>\n  </ng-container>\n</ng-container>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(0, core.Optional()),
            __metadata("design:paramtypes", [OavSettings])
        ], OverviewViewEndpointsComponent);
        return OverviewViewEndpointsComponent;
    }());

    function identifySchemaInfo(defaultName, schema) {
        var additionalModels = [];
        var modelInfo = identifyModelInfo(defaultName, readSchema(schema), additionalModels);
        return __assign(__assign({}, modelInfo), { additionalModels: additionalModels });
    }
    function identifyModelInfo(defaultName, schema, additionalModels) {
        var info = {
            name: defaultName,
            type: readType(schema),
            schema: readSchema(schema),
            properties: null
        };
        var modelName = readModelName(info.schema);
        if (modelName) {
            info.name = modelName;
        }
        if (info.type === 'object' || info.type === 'array') {
            info.properties = readProperties(info.schema, additionalModels);
        }
        return info;
    }
    function readProperties(schema, additionalModels) {
        var e_1, _a;
        var properties = [];
        if (schema.properties) {
            properties.push.apply(properties, __spread(readPropertiesOfObject(schema)));
        }
        if (schema.additionalProperties) {
            properties.push(readProperty('...', schema.additionalProperties));
        }
        if (Array.isArray(schema.items)) {
            for (var i = 0; i < schema.items.length; i++) {
                properties.push(readProperty(i.toString(), schema.items[i]));
            }
        }
        else if (schema.items) {
            properties.push(readProperty('', schema.items));
        }
        if (schema.additionalItems) {
            properties.push(readProperty('...', schema.additionalItems));
        }
        try {
            for (var properties_1 = __values(properties), properties_1_1 = properties_1.next(); !properties_1_1.done; properties_1_1 = properties_1.next()) {
                var prop = properties_1_1.value;
                var identifiedModel = updateModelsFromProperty(prop.name + 'Object', prop.schema, additionalModels);
                prop.modelName = identifiedModel;
                if (!identifiedModel && (prop.type === 'object' || prop.type === 'array')) {
                    prop.properties = readProperties(prop.schema, additionalModels);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (properties_1_1 && !properties_1_1.done && (_a = properties_1.return)) _a.call(properties_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return properties;
    }
    function updateModelsFromProperty(defaultName, schema, additionalModels) {
        if (schema.$ref) {
            // Unknown schema, probably did not resolved because of recursive structure
            var parts = schema.$ref.split('/');
            return parts.pop();
        }
        var refName = readModelName(schema);
        var type = readType(schema);
        if (type === 'object') {
            if (!schema.properties && !schema.additionalProperties) {
                return null;
            }
            var modelName_1 = refName || defaultName;
            if (!additionalModels.find(function (m) { return m.name === modelName_1; })) {
                var designatedIndex = additionalModels.length;
                var modelInfo = identifyModelInfo(modelName_1, schema, additionalModels);
                additionalModels.splice(designatedIndex, 0, modelInfo);
            }
            return modelName_1;
        }
        return null;
    }
    function readSchema(schema) {
        if (typeof schema === 'boolean') {
            return { type: 'boolean' };
        }
        return schema;
    }
    function readType(schema) {
        if (schema && typeof schema === 'object' && schema.type) {
            return Array.isArray(schema.type) ? schema.type[0] : schema.type;
        }
        if (typeof schema === 'boolean') {
            return 'boolean';
        }
        if (schema.properties || schema.additionalProperties) {
            return 'object';
        }
        if (schema.items || schema.additionalItems) {
            return 'array';
        }
        return null;
    }
    function readModelName(schema) {
        if (schema.$$ref) {
            var refParts = schema.$$ref.split('/');
            return refParts.pop();
        }
        return undefined;
    }
    function readPropertiesOfObject(schema) {
        if (schema.properties) {
            var requiredFields_1 = schema.required || [];
            return Object.keys(schema.properties).map(function (name) { return readProperty(name, schema.properties[name], requiredFields_1.includes(name)); });
        }
        return [];
    }
    function readProperty(name, schema, required) {
        if (required === void 0) { required = false; }
        var s = readSchema(schema);
        return { name: name, type: readType(s), schema: s, required: required };
    }

    var JsonSchemaComponent = /** @class */ (function () {
        function JsonSchemaComponent() {
        }
        JsonSchemaComponent.prototype.ngOnChanges = function (changes) {
            var info = identifySchemaInfo(this.defaultModelName, this.schema);
            info.open = true;
            this.models = __spread([info], info.additionalModels);
        };
        JsonSchemaComponent.prototype.isPrimitive = function (type) {
            return type === 'integer' || type === 'number' || type === 'string' || type === 'boolean' || type === 'null' || type === 'any';
        };
        JsonSchemaComponent.prototype.toggleModel = function (model) {
            if (model.open) {
                model.open = false;
            }
            else {
                model.open = true;
            }
        };
        JsonSchemaComponent.prototype.toggleModelByName = function (name) {
            var modelInfo = this.models.find(function (m) { return m.name === name; });
            if (modelInfo) {
                this.toggleModel(modelInfo);
            }
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], JsonSchemaComponent.prototype, "schema", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], JsonSchemaComponent.prototype, "defaultModelName", void 0);
        JsonSchemaComponent = __decorate([
            core.Component({
                selector: 'oav-json-schema',
                template: "<div class=\"oav-json-schema-description ml-0\" *ngIf=\"schema?.description\">\n  <markdown [data]=\"schema?.description\"></markdown>\n</div>\n<div *ngFor=\"let model of models\">\n  <ng-container *ngIf=\"model.type === 'object'\">\n    <div *ngIf=\"!model.open\" class=\"oav-json-schema-code\">\n      <a href=\"javascript:\" (click)=\"toggleModel(model)\" class=\"oav-json-schema-toggle\">\n        {{ model.name }}\n      </a>\n      {{ '{' }} <a href=\"javascript:\" (click)=\"toggleModel(model)\" class=\"oav-json-schema-toggle\">...</a> {{ '}' }}\n    </div>\n    <ng-container *ngIf=\"model.open\">\n      <div class=\"oav-json-schema-code\">\n        <a href=\"javascript:\" (click)=\"toggleModel(model)\" class=\"oav-json-schema-toggle\">\n          {{ model.name }}\n        </a>\n        {{ '{' }}\n      </div>\n      <div class=\"ml-3 json-schema-property\" *ngFor=\"let prop of model.properties\">\n        <div class=\"oav-json-schema-name oav-json-schema-code\" [class.oav-json-schema-required]=\"prop.required\">{{ prop.name }}:</div>\n        <div class=\"oav-json-schema-type\" *ngIf=\"!prop.modelName\">\n          <ng-container *ngTemplateOutlet=\"typeOutput; context: prop\"></ng-container>\n        </div>\n        <div class=\"oav-json-schema-type oav-json-schema-code\" *ngIf=\"prop.modelName\">\n          <a href=\"javascript:\" (click)=\"toggleModelByName(prop.modelName)\" class=\"oav-json-schema-toggle\">\n            {{ prop.modelName }}\n          </a>\n        </div>\n        <div class=\"oav-json-schema-description\">\n          <markdown *ngIf=\"prop.schema?.description\" [data]=\"prop.schema?.description\"></markdown>\n        </div>\n      </div>\n      <div class=\"oav-json-schema-code\">{{ '}' }}</div>\n    </ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"model.type === 'array'\">\n    <ng-container *ngTemplateOutlet=\"arrayOutput; context: model\"></ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"isPrimitive(model.type)\">\n    <ng-container *ngTemplateOutlet=\"typeOutput; context: model\"></ng-container>\n  </ng-container>\n</div>\n\n<ng-template #arrayOutput let-properties=\"properties\">\n  <ng-container *ngIf=\"properties?.length === 1 && properties[0] as prop; else multipleProps\">\n    <div class=\"oav-json-schema-code\" *ngIf=\"prop.modelName\">\n      [\n      <a href=\"javascript:\" (click)=\"toggleModelByName(prop.modelName)\" class=\"oav-json-schema-toggle\">\n        {{ prop.modelName }}\n      </a>\n      ]\n    </div>\n    <div class=\"oav-json-schema-code\" *ngIf=\"!prop.modelName\">\n      [ <span class=\"oav-json-schema-type-name\">{{ prop.type }}</span> ]\n    </div>\n  </ng-container>\n  <ng-template #multipleProps>\n    <div class=\"oav-json-schema-code\">[</div>\n    <div class=\"ml-3 json-schema-property\" *ngFor=\"let prop of properties\">\n      <div class=\"oav-json-schema-name oav-json-schema-code\" *ngIf=\"prop.name\">{{ prop.name }}:</div>\n      <div class=\"oav-json-schema-type\" *ngIf=\"!prop.modelName\">\n        <ng-container *ngTemplateOutlet=\"typeOutput; context: prop\"></ng-container>\n      </div>\n      <div class=\"oav-json-schema-type oav-json-schema-code\" *ngIf=\"prop.modelName\">\n        <a href=\"javascript:\" (click)=\"toggleModelByName(prop.modelName)\" class=\"oav-json-schema-toggle\">\n          {{ prop.modelName }}\n        </a>\n      </div>\n      <div class=\"oav-json-schema-description\">\n        <markdown *ngIf=\"prop.schema?.description\" [data]=\"prop.schema?.description\"></markdown>\n      </div>\n    </div>\n    <div class=\"oav-json-schema-code\">]</div>\n  </ng-template>\n</ng-template>\n\n<ng-template #typeOutput let-type=\"type\" let-schema=\"schema\" let-properties=\"properties\">\n  <ng-container *ngIf=\"type === 'array'\">\n    <ng-container *ngTemplateOutlet=\"arrayOutput; context: { properties: properties }\"></ng-container>\n  </ng-container>\n  <ng-container *ngIf=\"type !== 'array'\">\n    <span class=\"oav-json-schema-type-name oav-json-schema-code\">\n      {{ type }}\n    </span>\n    <span class=\"oav-json-schema-format oav-json-schema-code\" *ngIf=\"schema?.format\">({{ schema?.format }})</span>\n    <span *ngIf=\"schema?.enum?.length\" class=\"oav-json-schema-code\">({{ schema.enum.join(' | ') }})</span>\n  </ng-container>\n</ng-template>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __metadata("design:paramtypes", [])
        ], JsonSchemaComponent);
        return JsonSchemaComponent;
    }());

    var OpenapiViewerModule = /** @class */ (function () {
        function OpenapiViewerModule() {
        }
        OpenapiViewerModule = __decorate([
            core.NgModule({
                declarations: [
                    OpenapiViewerComponent,
                    OperationComponent,
                    ParameterComponent,
                    ResponsesComponent,
                    MultiItemsInputComponent,
                    RequestsListComponent,
                    RequestViewComponent,
                    OpenableDirective,
                    MethodHeaderComponent,
                    MethodComponent,
                    IndexNavComponent,
                    OperationViewComponent,
                    OverviewViewComponent,
                    TabNavComponent,
                    TabNavItemDirective,
                    TemplateOutletComponent,
                    RequestBodyInputComponent,
                    AuthenticationViewComponent,
                    AuthCredentialsComponent,
                    AuthStatusComponent,
                    TooltipComponent,
                    TooltipDirective,
                    CodeInputComponent,
                    IndexNavEndpointsComponent,
                    OverviewViewEndpointsComponent,
                    ModelsViewComponent,
                    JsonSchemaComponent
                ],
                imports: [
                    common.CommonModule,
                    OpenapiViewerRoutingModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule,
                    http.HttpClientModule,
                    ngxMarkdown.MarkdownModule.forRoot(),
                    portal.PortalModule,
                    overlay.OverlayModule,
                    ngxAceWrapper.AceModule
                ],
                exports: [OpenapiViewerComponent, OperationComponent]
            })
        ], OpenapiViewerModule);
        return OpenapiViewerModule;
    }());

    exports.OavSettings = OavSettings;
    exports.OpenapiAuthService = OpenapiAuthService;
    exports.OpenapiViewerComponent = OpenapiViewerComponent;
    exports.OpenapiViewerModule = OpenapiViewerModule;
    exports.OpenapiViewerService = OpenapiViewerService;
    exports.OperationComponent = OperationComponent;
    exports.buildAuthorizationUrl = buildAuthorizationUrl;
    exports.defaultOavSettings = defaultOavSettings;
    exports.getAuthorizationBaseUrl = getAuthorizationBaseUrl;
    exports.getTagsOfPath = getTagsOfPath;
    exports.getTokenBaseUrl = getTokenBaseUrl;
    exports.identifyFlows = identifyFlows;
    exports.ɵa = ParameterComponent;
    exports.ɵb = ResponsesComponent;
    exports.ɵc = MultiItemsInputComponent;
    exports.ɵd = RequestsListComponent;
    exports.ɵe = RequestViewComponent;
    exports.ɵf = OpenableDirective;
    exports.ɵg = MethodHeaderComponent;
    exports.ɵh = MethodComponent;
    exports.ɵi = IndexNavComponent;
    exports.ɵj = OperationViewComponent;
    exports.ɵk = OverviewViewComponent;
    exports.ɵl = TabNavComponent;
    exports.ɵm = TabNavItemDirective;
    exports.ɵn = TemplateOutletComponent;
    exports.ɵo = RequestBodyInputComponent;
    exports.ɵp = AuthenticationViewComponent;
    exports.ɵq = AuthCredentialsComponent;
    exports.ɵr = AuthStatusComponent;
    exports.ɵs = TooltipComponent;
    exports.ɵt = TooltipDirective;
    exports.ɵu = CodeInputComponent;
    exports.ɵv = IndexNavEndpointsComponent;
    exports.ɵw = OverviewViewEndpointsComponent;
    exports.ɵx = ModelsViewComponent;
    exports.ɵy = JsonSchemaComponent;
    exports.ɵz = OpenapiViewerRoutingModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dhcode-openapi-viewer.umd.js.map
