import { OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { ParameterObject } from 'openapi3-ts';
import { FormControl, FormGroup } from '@angular/forms';
export declare class ParameterComponent implements OnChanges, OnDestroy {
    formGroup: FormGroup;
    parameter: ParameterObject;
    mediaType: string;
    displayMode: string;
    value: any;
    control: FormControl;
    enum: any[];
    constructor();
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
}
