import { ChangeDetectorRef, ElementRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { OperationObject } from 'openapi3-ts';
import { OavSettings } from '../../models/openapi-viewer.settings';
import { OpenapiAuthService } from '../../services/openapi-auth.service';
import { AuthStatus, SecurityRequirementStatus } from '../../models/openapi-viewer.model';
import { CdkPortal } from '@angular/cdk/portal';
export declare class AuthStatusComponent implements OnChanges, OnInit, OnDestroy {
    private oavSettings;
    private authService;
    private cd;
    operation: OperationObject;
    portal: CdkPortal;
    statusIcon: ElementRef;
    authStatus: AuthStatus;
    showAuthentication: boolean;
    requiredSchemes: SecurityRequirementStatus[][];
    schemeNames: any[];
    private sub;
    constructor(oavSettings: OavSettings, authService: OpenapiAuthService, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
}
