import { OnChanges, SimpleChanges } from '@angular/core';
import { ModelInfo } from '../../util/schema-info.util';
import { SchemaObject } from 'openapi3-ts';
export declare class JsonSchemaComponent implements OnChanges {
    schema: SchemaObject;
    defaultModelName: string;
    models: ModelInfo[];
    constructor();
    ngOnChanges(changes: SimpleChanges): void;
    isPrimitive(type: string): boolean;
    toggleModel(model: ModelInfo): void;
    toggleModelByName(name: any): void;
}
