import { OnDestroy, OnInit } from '@angular/core';
import { AbstractControl, ControlValueAccessor, FormArray, FormGroup } from '@angular/forms';
export declare class MultiItemsInputComponent implements OnInit, OnDestroy, ControlValueAccessor {
    name: string;
    required: any;
    disabled: boolean;
    values: FormArray;
    formGroup: FormGroup;
    private subscription;
    constructor();
    private onChange;
    onTouched: () => void;
    ngOnInit(): void;
    get isRequired(): boolean;
    get controls(): AbstractControl[];
    ngOnDestroy(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(obj: string[]): void;
    addControl(): void;
    removeValue(index: number): void;
}
